	
	FUNCTION call_chi(R,NUM,NBOITES,kpas)

!	Appelle FUNCTION CHI2 (R,NUM,NBOITES,    Valeurs a fournir a la fonction
!                LIMT,IERR,BIAIS,VARMIN,VARMAX,FINT,FTH)  Parametres annexes
!                                                         rendus par la fonction
!
!      R         tableau de la variable a analyser, R*4, dimension NUM (NUM > 100)
!      NBOITES   nombre d'intervalles pour la partition
!----------------
!      LIMT   nombre de valeurs eliminees (a 2.5 sigma) pour effectuer le test
!      IERR   code d'erreur donnant le nombre d'intervalles ayant moins de 5
!             valeurs.Si au moins un intervalle contient moins de 3 valeurs,
!             le Chi2 est mis a 0.Il est recommande de tester la valeur de IERR
!             a la sortie de la fonction
!      BIAIS  valeur moyenne de VAR,apres elimination des valeurs >2.5 sigma
!      VARMIN barre inferieure d'analyse (R*8)
!      VARMAX barre superieure d'analyse (R*8)
!      FINT   largeur d'un intervalle (R*8)
!      FTH    frequence theorique pour chaque intervalle (dimension NINT)
!
!USAGE      : Declarer VARMIN,VARMAX,FINT en (R*8)
!             Dimensionner R (R*4) et FTH (R*4)
!             Definir le nombre d'intervalles NBOITES.

!                                                       Auteur: Felicitas Arias
!                                                               farias@bipm.org

	Implicit None
	Real*4  call_chi 

	Integer*4 LIMT,IERR,num,nboites,kpas
	Real*4  BIAIS, R(num),FTH(num),chi,CHI2
	Real*8  VARMIN,VARMAX,FINT

c	type*,'Synt_chi:',num,nboites,kpas

	chi=0.
 2750	continue
 	chi=CHI2(r,num,nboites,LIMT,IERR,BIAIS,VARMIN,VARMAX,FINT,FTH)

	IF (chi.eq.0)	THEN
c	   write(6,16)ierr,nboites,chi
c	   write(16,16)ierr,nboites
 16	   format('Call_chi:',i4,'/',i6,' boites vides. Chi^2:',f8.2)
       	   nboites=nboites-kpas		
	   if(nboites.gt.0) go to 2750

c	   write(6,17)ierr,nboites
	   write(16,17)ierr,nboites
 17	   format('Call_chi:',i4,'/',i6,' boites vides. Je sors ')
	   call_chi=0.
	   Return
	ENDIF

	call_chi=chi
	   write(6,16)ierr,nboites,chi
	Return
	End

