!       f77 -C crono_vue.f -o crono_vue; rm crono_vue.o

!       Lecture de la serie chronologique
!       Transmission a crono.f: 
!                     date MJD, valeur (seri de ELSER), sigma (eventuellement 0)
!       Retour de chrono.f (memes unite qu'a l'aller):
!                     Commons ELSER, SPECTRES, CYCL, STAT
!       Sorties pour les graphique: exclusivite des sorties, sauf write(16,...
!       Tous les logiciels utilises sont susceptibles d'ecrire dans le .echo (16)
!       Gere les changements d'unite en sortie/l'entree

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,Nsp,Ncc,Nst
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nsp=1000)   ! Nb de pts du spectre (spfil.f)
	Parameter (Ncc=1000)   ! Nb de cycles sur la duree totale 
	Parameter (Nst=1000)   ! Nb de variances d'Allan (common STAT)


	Character*1  monu,ut_ent,ut_sor,ut_sp,utend,usais,
	1            undeux(2)
	Character*4  resu(5),avsan(2)
	Character*31  sta              
      	Real*8       truc,tab,tabul
      	Real*4       factar,cotdeb,cotfin,dcot,cotydeb,dcoty,
c	1            tab,tabul,
	2            filtre,cycla,cyclb,BINSUP,
	3            sercot(NF),sercor(NF),cotst,cotsp,cotamp
	Integer*4    I,J,k,kpo,ks,kspt,L,lpsb,lvar,ltit,ncot,ncor

!       Declarations pour transferer les donnees a CRONO

	Character*6  uni_var                 ! nom de l'unite en sortie
      	Real*8       date,djou               ! dates MJD
      	Real*4       tref,geri,ajou          ! tref: numero
	Integer*4    njou
	COMMON/DONNEES/date(NF),uni_var,tref(NF),geri(NF)
	COMMON/AJOUS/djou(NF),ajou(NF),njou

!       Declarations pour l'interface avec ELFIL

      	Real*4 BP,BI,belim,DATDEP,SERI,TEND,SAIS,SAISb,REST
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),saisB(NF),REST(NF)

!       Declarations pour l'interface avec SPFIL

      	Real*4       frq,amp,samp,pt,perinf,persup,
	1            x1,xper1,x2,xper2,x3,xper3,x4,xper4
	Integer*4    NR
	COMMON/SPECTRES/frq(Nsp,2),amp(Nsp,2),samp(Nsp,2),NR(2),pt(NF)
	1               ,perinf(2),persup(2)

!       Pour recevoir les variations du cyclique

	Real*8    datecy
	Real*4    cyc,scyc
	Integer*4 ncy,NS
	Common/CYCL/datecy(Ncc,2),cyc(Ncc,2,2),scyc(Ncc,2,2),ncy(2),NS
!        0         0         0         0         0         0         *72*

!       Pour recevoir les stat de NETCENT

      	Real*8      dlim
      	Real*4      elim,centre,ecmax,fac
	Integer*4   nlim
	COMMON/ELIMS/dlim(NF),elim(NF),nlim,centre,ecmax,fac

!       Pour recevoir les stat de VARBRUIT

	Real*4       biastend,pentend,spentend,pent,sent,pv,
	1            rms_rest,chi_rest,tz,vz,pcy,cab,pentre
	Integer*4    nvz,kab
	Common/STAT/pcy(3),kab,biastend,pentend,spentend,pent(7),sent(7),
     .              tz(Nst,7),vz(Nst,7),nvz(7),rms_rest,chi_rest,pv(NF)
!       1: tend+rest; 2:tend;  3: rest;    
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2

!       Pour DIVERSIG

      	Real*4      DIVERSIG,vsr(nst),vpr(nst),vrr(nst)

!       Pour la sortie crono_gmt.sh

	Character*300  chaine
	Real*4         xd,xf,yd,yf,y0,dx,dy,xe,ye
	Integer*4      lch,kx,kyv,kav,kbv,kxv,kxa,kxb


	data avsan/'sans','avec'/
	data undeux/'A','B'/
	data resu/'Tout','Tend','CycA','Rest','CycB'/

	Real*8    DMJD,DAN,DMJW,GPW,DANN,DJD
!	DMJW(GPW)=51548.5d0+(GPW-1043.0d0)*7.d0       ! GPS weeks => MJD central
	DMJW(GPW)=51545.d0+(GPW-1043.0d0)*7.d0       ! GPS weeks => MJD central
	DMJD(DAN)=51544.03d0+(DAN-2000.0d0)*365.2422d0 ! Annees => MJD
	DANN(DJD)=2000.0d0+(DJD-51544.03d0)/365.2422d0 ! MJD => Annees

	open(1,status='old',readonly,file='crono_vue.dat')
	open(3,status='old',readonly,file='crono_vue.serie')	

	open(16,status='unknown',file='crono_vue.echo')


!                   +- ----------------------------------+
!                   | Lecture des instructions d'analyse |
!                   +- ----------------------------------+

!       Unite de temps et intervalle tabulaire en entree
!       ------------------------------------------------

	read(1,*) monu,tab
!       Ex.: 's' 1 ; 'h' 1 ; 'd' 5; 'w' 1 ; 'm' 1 ; 'a' .20 ;
!        0         0         0         0         0         0         |72	
	IF (monu.ne.'s'.and.monu.ne.'h'.and.monu.ne.'d'.and.monu.ne.'w' 
	1  .and.monu.ne.'m'.and.monu.ne.'a') THEN
	   type*,'** ERREUR: Ligne 1 de crono_gmt.dat:',
	1  ' unite tabulaire <',monu,'> non reconnue'
	   type*,'** On accepte: ''s'', ''h'', ''d'', ''w'''
	1	,' ''m'', ''a'' '
	   STOP
	ENDIF

c	type*,'1'

!       Dates, intervalle tabulaire => annees

	if(monu.eq.'s') tabul= tab/(3600.d0*24.d0*365.2422d0)
	if(monu.eq.'h') tabul= tab/(24.d0*365.2422d0)
	if(monu.eq.'d') tabul= tab/365.2422d0
	if(monu.eq.'w') tabul= tab*7.d0/365.2422d0
	if(monu.eq.'m') tabul= tab/12.d0
	if(monu.eq.'a') tabul= tab

!       Unite de temps en ENTREE ('d'=MJD;'a'=annees;'w'=GPS week)
!       Unite de temps en SORTIE ('d'=MJD;'a'=annees)
!       ----------------------------------------------------------

	read(1,*)  ut_ent, ut_sor ,ut_sp    

c	type*,'2'

	IF (ut_ent.ne.'d'.and.ut_ent.ne.'a'.and.
	1   ut_ent.ne.'w') THEN
	   type*,'** ERREUR: Ligne 2 de crono_gmt.dat:',
	1	' unite de temps en entree <',
	1  ut_ent,'> non prevue'
	   type*,'** On accepte les datations ''d'' (MJD),'
	1	, ' ''a'' (annees) et ''w'' (GPS week)'
	   STOP
	ENDIF

	IF ( ut_sor.ne.'d'.and.ut_sor.ne.'a') THEN
	   type*,'** ERREUR: Ligne 2 de crono_gmt.dat:',
	1	' unite de temps en sortie <',
	1  ut_sor,'> non prevue'
	   type*,'** On accepte les datations ''d'' (MJD) et'
	1	, ' ''a'' (annees)'
	   STOP
	ENDIF

	IF ( ut_sp.ne.'h'.and.
	1    ut_sp.ne.'d'.and.ut_sp.ne.'a') THEN
	   type*,'** ERREUR: Ligne 2 de crono_gmt.dat:',
	1	' unite de temps spectres <',
	1  ut_sp,'> non prevue'
	   type*,'** On accepte les datations ''h'' (heures),'
	1	, ' ''d'' (MJD) et ''a'' (annees)'
	   STOP
	ENDIF

!       Cotes deb-fin des dates a tracer et intervalle des marques
!       (si = 1ere et dern date: 0 0 0) 
!       -----------------------------------------------------

	read(1,*) cotdeb,cotfin,dcot    

c	type*,'3'

!        Nom de la variable en SORTIE (max a6), 
!        facteur multiplicatif a appliquer a l'unite ENTREE
!       -----------------------------------------------------

	read(1,*) uni_var, factar    
!'cm' 10.   Nom_ variable en SORTIE, fact. mult. a appliquer a l'unite ENTREE

c	type*,'4'

!       On ne conserve que les caracteres utiles (= non vides a gauche)
	do L=6,1,-1
	   lvar=L
	   if(uni_var(L:L).ne.' ') go to 55
	enddo
 55	continue

!       |cote max +-y|, a tracer et intervalle des marques
!       (si = 1ere et dern date: 0 0) 
!       -----------------------------------------------------

	read(1,*) cotydeb,dcoty

c	type*,'5'

!       Largeur filtre tendance (unite de tps: 's'; 'h';'d';'w';'m';'a')
!       ----------------------------------------------------------------

	read(1,*) utend,filtre      

c	type*,'6'

	IF (utend.ne.'s'.and.utend.ne.'h'.and.utend.ne.'d'.and. 
	1   utend.ne.'w'.and.utend.ne.'m'.and.utend.ne.'a') THEN
	   type*,'** ERREUR: Ligne 5 de crono_gmt.dat: ',
	1	' unite de temps pour filtre', 
	1  'tendance <',utend,'> non reconnue'
	   type*,'** On accepte: ''s'',  ''h'', ''d'', ''w''', 
	1	' ''m'', ''a'' '
	   STOP
	ENDIF

c	if(utend.eq.ut_ent) limp=(filtre/tab)+0.5

!       => filtre en annees

	if(utend.eq.'s') filtre= filtre/(3600.d0*24.d0*365.2422d0)
	if(utend.eq.'h') filtre= filtre/(24.d0*365.2422d0)
	if(utend.eq.'d') filtre= filtre/365.2422d0
	if(utend.eq.'w') filtre= filtre*7.d0/365.2422d0
	if(utend.eq.'m') filtre= filtre/12.d0

	write(6,203) filtre
	write(16,203) filtre
 203	format(' Filtre tendance',f10.4,' a')

!       => filtre nombre de points

	limp=0.5+(filtre/tabul)   
	lpair=limp

!       Deux valeurs de cycle (unite de tps: 's'; 'h';'d';'m';'a')
!       -----------------------------------------------------

	read(1,*) usais,cycla,cyclb,cab     

c	type*,'7'

	IF (usais.ne.'s'.and.usais.ne.'h'.and.usais.ne.'d'.and. 
	1   usais.ne.'w'.and.usais.ne.'m'.and.usais.ne.'a') THEN
	   type*,'** ERREUR: Ligne 6 de crono_gmt.dat: ',
	1	' unite periodes cycliques <',
	1  usais,'> non reconnue'
	   type*,'** On accepte: ''s'', ''h'', ''d'', ''w'',',
	1	' ''m'', ''a'' '
	   STOP
	ENDIF
!        0         0         0         0         0         0         *72*
!       => periodes des cycles en annees
	if(cycla.ne.0.and.cyclb.ne.0) NS=2
	if(cycla.ne.0.and.cyclb.eq.0) NS=1
	IF (cycla.eq.0.and.cyclb.ne.0) THEN
	   cycla=cyclb
	   cyclb=0
	   NS=1
	ENDIF
	if(cycla.eq.0.and.cyclb.eq.0) NS=0

	lps=0
	lpsb=0   
	kab=0

	IF (NS.eq.0) THEN	
	   write(6,2000) 
	   write(16,2000) 
 2000	   format(' Pas de composante cyclique')
!          C'est crono.f qui reagit a NS=0
	ENDIF

	IF (NS.eq.1) THEN	
	   write(6,2001) cycla,usais
	   write(16,2001) cycla,usais
 2001	   format(' Une composante cyclique:',
	1  f8.2,1x,a1)

	   if(usais.eq.'s') cycla= cycla/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cycla= cycla/(24.d0*365.2422d0)
	   if(usais.eq.'d') cycla= cycla/365.2422d0
	   if(usais.eq.'w') cycla= cycla*7.d0/365.2422d0
	   if(usais.eq.'m') cycla= cycla/12.d0

!       => periode du premier cyclique en nombre de points

	   lps=0.5+(cycla/tabul)   
	ENDIF

	IF (NS.eq.2) THEN	
	   write(6,2202)  cycla,cyclb,usais
	   write(16,2202) cycla,cyclb,usais
 2202	   format(' Deux composantes cycliques,',2f8.2,1x,a1)
	   if(cab.ne.0) write(6,2002)  cab,usais
	   if(cab.ne.0) write(16,2002) cab,usais 
 2002	   format('           Commensurabilite:',f8.2,1x,a1)

	   if(usais.eq.'s') cycla= cycla/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cycla= cycla/(24.d0*365.2422d0)
	   if(usais.eq.'d') cycla= cycla/365.2422d0
	   if(usais.eq.'w') cycla= cycla*7.d0/365.2422d0
	   if(usais.eq.'m') cycla= cycla/12.d0

!          => periode du premier cyclique en nombre de points

	   if(usais.eq.'s') cyclb= cyclb/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cyclb= cyclb/(24.d0*365.2422d0)
	   if(usais.eq.'d') cyclb= cyclb/365.2422d0
	   if(usais.eq.'w') cyclb= cyclb*7.d0/365.2422d0
	   if(usais.eq.'m') cyclb= cyclb/12.d0

!           => periode du deuxieme cyclique en nombre de points

	   if(usais.eq.'s') cab= cab/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cab= cab/(24.d0*365.2422d0)
	   if(usais.eq.'d') cab= cab/365.2422d0
	   if(usais.eq.'w') cab= cab*7.d0/365.2422d0
	   if(usais.eq.'m') cab= cab/12.d0

!           => periode du cycle commensurable en nombre de points

	   lps=0.5+(cycla/tabul)   
	   lpsb=0.5+(cyclb/tabul)   
	   kab=0.5+(cab/tabul)   

	ENDIF

c	type*,'=== lps, lpsb',lps,lpsb

!       Valeurs frontieres pour les rabotages
!       -------------------------------------

	read(1,*) fac,belim,bp,bi ! pour rabotages (2 2 1 ??)

	type*,'-- Fin de lecture de crono_vue.dat --'


!       +---------------------------------------------------------+
!       | Lecture des donnees, avec ou sans sigmas (format libre) |
!       +---------------------------------------------------------+

!       Avec/sans sigma (1/0), Titre (a6)
!       ---------------------------------

	read(3,*) kpo,sta       

	do L=31,1,-1
	   ltit=L
	   if(sta(L:L).ne.' ') go to 65
	enddo
 65	continue

	write(6,5)  sta(1:ltit), avsan(kpo+1)    
	write(16,5) sta(1:ltit), avsan(kpo+1)       
 5	format(' -- ',a,': donnees ',a,' sigmas')

	I=0
  100	continue
	I=I+1
110	continue
	geri(I)=0.

	if(kpo.eq.0) read(3,*,end=200) date(I),seri(I) 
	if(kpo.eq.1) read(3,*,end=200) date(I),seri(I),geri(I)

!       Transfo d'unites: variable et echelle de temps

c	type*,I, date(I),seri(I),geri(I)

	IF (I.gt.NF) THEN
	   type*,'** ERREUR: I > NF:',Ntot,' >',NF
	   STOP
	ENDIF

	seri(I)=seri(I)*factar  ! => unite SORTIE pour la variable
	geri(I)=geri(I)*factar  ! => unite SORTIE pour la variable

	if(ut_ent.eq.'w') date(I)=DMJW(date(I)) ! GPS week =>date MJD
	if(ut_ent.eq.'a') date(I)=DMJD(date(I)) ! ans =>date MJD

	tref(I)=1.+(date(I)-date(1))/(tabul*365.2422d0) ! entier/premiere date
c	type*,I,date(I),tref(I),seri(I)

!       Dans le cas 'd', on a deja la date en MJD

	go to 100
  200	continue
	Ntot=I-1

c	type*,ntot,tref(ntot)

	IF (tref(ntot).gt.FLOAT(NF)) THEN
	   type*,'** ERREUR: La serie completee sera trop longue:'
	1	 ,tref(ntot),' >',NF
	   STOP
	ENDIF

	write(6,201)  ntot,date(1),date(ntot),
	1             tref(ntot),tabul*365.2422
	write(16,201) ntot,date(1),date(ntot),
	1             tref(ntot),tabul*365.2422
 201	format(i7,' mes., MJD:',2f8.1,'. - ',
	1      f7.0,' intervalles de',f10.5,' jours.')

!       Controle de la coherence des cycliques demandees
!       avec la duree des donnees (duree > 5 cycles)

	IF (NS.ne.0) THEN
	   if(cycla*365.2422.ge.(date(ntot)-date(1))/5.d0) 
	1  type*,'** ERREUR: ',
	2	 'Cycle 1 demande',cycla,' ',usais,' trop long'
	   if(cyclb*365.2422.ge.(date(ntot)-date(1))/5.d0) 
	1  type*,'** ERREUR: ',
	2	 'Cycle 2 demande',cyclb,' ',usais,' trop long'

	   IF (cycla*365.2422.ge.(date(ntot)-date(1))/5.d0.or.
	1      cyclb*365.2422.ge.(date(ntot)-date(1))/5.d0) THEN
	       type*,'** ERREUR: Valeur max possible:',
	1	     ' 1/5 de la duree des obs'
	       STOP
	   ENDIF
	ENDIF
	

!                  +------------------------------------+
!                  | Filtrages et analyses statistiques |
!                  +------------------------------------+

	CALL CRONO(ntot,kpo,lpsb)

!                             +---------+
!	                      | SORTIES |
!                             +---------+

!       Sortie des points aberrants elimines avant analyse (NETCENT)

	open(26,status='unknown',file='crono_gmt.elim')

	do 209 I=1,nlim	         
	   truc=dlim(I)                                ! MJD
	   if(ut_sor.eq.'a')truc=DANN(dlim(I))         ! ans
	   write(26,*) truc,elim(I)-centre,I,centre
c	   write(6,*) truc,elim(I)-centre,I,centre
 209	continue

	Close (26)

!       Sortie des points ajoutes pour combler les trous (CRONO)

	open(26,status='unknown',file='crono_gmt.ajou')

	do 219 I=1,njou	         
	   truc=djou(I)                                ! MJD
	   if(ut_sor.eq.'a')truc=DANN(djou(I))         ! ans
	   write(26,2190) truc,ajou(I),I,centre
 2190	   format(f12.5,f12.4,i5,f12.4)
c	   write(6,*) truc,ajou(I)-centre,I,centre
 219	continue

	Close (26)

!       Sortie des sries du common ELFIL en unites SORTIE (uni_var)

	open(7, status='unknown',file='crono_gmt.tout')
	open(8, status='unknown',file='crono_gmt.tend')
	open(9, status='unknown',file='crono_gmt.saisA')
	open(10,status='unknown',file='crono_gmt.rest')
	if(NS.eq.2) 
	1 open(11,status='unknown',file='crono_gmt.saisB')

	do 300 k=7,11
	   DO 124 I=1,Ntot
	      if(pt(I).eq.0.) go to 124
	      truc=date(I)                                ! MJD
	      if(ut_sor.eq.'a')truc=DANN(date(I))         ! ans

	      pentre=biastend+pentend*(date(I)-date(1))

	      if(k.eq.7) write(k,1) truc,(seri(I)-pentre),geri(I),
	1	                    tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.8) write(k,1) truc,(tend(I)-pentre),geri(I),
	1	                    tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.9) write(k,1) truc,sais(I),geri(I),
	1	                    tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.10) write(k,1) truc,rest(I),geri(I),
	1	                     tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.11.and.NS.eq.2) 
	1	          write(k,1) truc,saisB(I),geri(I),
	2	                     tref(I), resu(k-6),sta(1:ltit)
!        0         0         0         0         0         0         |72
    1	      format(f15.8,2f12.4,f7.0,1x,a,1x,a)
 124	   CONTINUE
 300	CONTINUE

	Close (7)
	Close (8)
	Close (9)
	Close (10)
	Close (11)


!       Sortie des spectres du common SPECTRES
!       Unites:  "uni_var" et cycles/"ut_sp"

!              On repere la presence d'un spectre de la tendance (kspt=1)
	kspt=1
	if(samp(1,1).eq.0.and.samp(9,1).eq.0)	kspt=0

	if(kspt.eq.1) open(12,status='unknown',file='crono_gmt.sp_tend')
	open(13,status='unknown',file='crono_gmt.sp_rest')

	   ncot=0
	   ncor=0
	do 400 k=2-kspt,2        !  tend:k=1; rest:k=2
	   DO 350 I=1,NR(k)
	      truc=frq(I,k)                            ! cycle/jour
	      if(ut_sp.eq.'h')truc=frq(I,k)/24.        ! cycle/heure
	      if(ut_sp.eq.'a')truc=frq(I,k)*365.2422   ! cycle/an
	      WRITE(k+11,2) truc,amp(I,k),samp(I,k),
	1	            1./truc,ut_sp,resu(2*k),sta(1:ltit)
 2	      FORMAT(f11.4,f12.4,f8.4,f10.3,' ',a,1x,a,1x,a)

	      IF (k.eq.1) THEN
		 ncot=ncot+1
		 sercot(ncot)= amp(I,k) ! pour cotst <= amplitudes de sp_tend
	      ENDIF
	      IF (k.eq.2) THEN
		 ncor=ncor+1
		 sercor(ncor)= amp(I,k) ! pour cotsp <= amplitudes de sp_rest
	      ENDIF
 350	   CONTINUE
 400	CONTINUE
	cotst=BINSUP(sercot,ncot,2)
	cotsp=BINSUP(sercor,ncor,2)

	Close (12)
	Close (13)

	ncot=0
	do 510 ks=1,NS   ! Pour les deux cycliques

!       Sortie des variations du cyclique et de sa premiere harmonique 

	   open(12,status='unknown',
	1	file='crono_gmt.cy_sais'//undeux(ks)//'1')
	   open(13,status='unknown',
	1	file='crono_gmt.cy_sais'//undeux(ks)//'2')

	   do 500 k=1,2      ! la fondamentale et la 1ere harmonique
	      DO 450 I=1,ncy(ks) ! la liste des amplitudes
		   ncot=ncot+1
		   sercot(ncot)=cyc(I,ks,1)  
                              ! pour cotamp (d'apres fondam A et B)
	           truc=datecy(I,ks)                           ! MJD
	           if(ut_sor.eq.'a')truc=DANN(datecy(I,ks))    ! ans
	           WRITE(k+11,3) truc,cyc(I,ks,k),scyc(I,ks,k),
	1	                 resu(2*ks+1),k,sta(1:ltit)
 3	         FORMAT(f12.4,f12.3,f9.3,2x,a4,i1,2x,a)

 450	      CONTINUE      ! I=1,ncy(ks)  la liste des amplitudes
 500	   CONTINUE         ! k=1,2        la fondamentale et la 1ere harmonique

	   Close (12)
	   Close (13)
 510	CONTINUE            ! ks=1,NS      les deux cycliques
	cotamp=BINSUP(sercot,ncot,2)

!       Sortie des stat

	if(ut_sor.eq.'a') pentend= pentend*365.2422
	if(ut_sor.eq.'a') spentend= spentend*365.2422
c	write(6,41) pentend,spentend,uni_var,ut_sor
c	write(16,41) pentend,spentend,uni_var,ut_sor
c 41	FORMAT(' Pente de la tendance:',f8.3,' +-',f7.3,' ',a6,'/',a1)

	type*,'Ecart-type du reste', rms_rest,' ',uni_var,
	1    '. Chi^2 du reste:',chi_rest

!       Sortie des variances d'Allan (cm, mois)
!       1: tend+rest; 2:tend;  3: rest;    
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2

	DO 550 k=1,5+2*(NS-1)    

	   if(k.eq.1) 
	1  open(9,status='unknown',file='crono_gmt.varp_tres')
	   if(k.eq.2) 
	1  open(10,status='unknown',file='crono_gmt.varp_tend')
	   if(k.eq.3) 
	1  open(11,status='unknown',file='crono_gmt.varp_rest')

	   if(k.eq.4) 
	1  open(12,status='unknown',file='crono_gmt.varp_ampA1')
	   if(k.eq.5)   !.and.NS.eq.2)
	1  open(13,status='unknown',file='crono_gmt.varp_ampA2')

	   if(k.eq.6)   !4) 
	1  open(14,status='unknown',file='crono_gmt.varp_ampB1')
	   if(k.eq.7)   !5.and.NS.eq.2)
	1  open(15,status='unknown',file='crono_gmt.varp_ampB2')

	   DO 540 L=1,nvz(k)

	      if(ut_sp.eq.'d')truc=ALOG10(tz(L,k))          ! jours
	      if(ut_sp.eq.'h')truc=ALOG10(tz(L,k)*24.) ! jours => heures
	      if(ut_sp.eq.'a')truc=ALOG10(tz(L,k)/365.2422) ! jours => ans

	      write(8+k,6) truc,ALOG10(vz(L,k)),k
 6	      FORMAT(2f8.4,'  0.',i6)

	      if(L.eq.1)      kx=truc*100.
	      if(L.eq.nvz(k)) kx=0.5+(truc*100.+FLOAT(kx))/200.
 540	   continue

!             Mediane des log(tau) pour le graphe

	      if(k.eq.1) kxv=kx    ! tend, rest
	      if(k.eq.4) kxa=kx    ! cyclA1
	      if(k.eq.6) kxb=kx    ! cyclB1

!             Mediane des log(varp) pour le graphe

	      IF (k.eq.1) THEN   
		 do L=1,nvz(k)
		    vsr(L)=ALOG10(vz(L,k))
		    vpr(L)=1
		 enddo
		 kyv=0.5+DIVERSIG(vsr,vpr,nvz(k),9,vrr) ! mediane tend
	      ENDIF

	      IF (k.eq.4) THEN   
		 do L=1,nvz(k)
		    vsr(L)=ALOG10(vz(L,k))
		    vsr(L+nvz(k))=ALOG10(vz(L,k+1))
		    vpr(L)=1
		 enddo
		 kav=0                                 
		 if(nvz(k).ne.0) kav=0.5+               ! centre ampA1,ampA2
	1	     0.5*(BINSUP(vsr,nvz(k),1)+BINSUP(vsr,nvz(k),2))
c		 type*,'kav',kav
	      ENDIF

	      IF (k.eq.6) THEN   
		 do L=1,nvz(k)
		    vsr(L)=ALOG10(vz(L,k))
		    vsr(L+nvz(k))=ALOG10(vz(L,k+1))
		    vpr(L)=1
		 enddo
		 kbv=0                               
		 if(nvz(k).ne.0) kbv=0.5+               ! centre ampB1,ampB2
	1	     0.5*(BINSUP(vsr,nvz(k),1)+BINSUP(vsr,nvz(k),2))
c		 type*,'kbv',kbv
	      ENDIF

 550	continue

	Close (9)
	Close (10)
	Close (11)
	Close (12)
	Close (13)
	Close (14)
	Close (15)

!                             +--------------------------+
!	                      | Creation de crono_gmt.sh |
!                             +--------------------------+

	open(10,status='unknown',file='crono_gmt.s')
	write(10,800) 
 800	format('#!/bin/sh'/'echo "Tout et tendance"')

!       Trois/quatre fenetres pour tout+tend, saisA/B, rest
!       Ordre de fabrication des cadres: 
!       C1, C2, C3; G3, G2, G1; D1, D2, D3. Schema:

!                               Sp1----------> Av1
!                               |               |
!                               |       Ts1     |
!                               Sp2      |     Av2
!                               |       Ts2     |
!                               |        |      |
!                               Sp3<----Ts3    Av3

	y0=0.

!       --------------------------
!       CADRE Ts1: Tout et tendance
!       --------------------------

!       Cas des cotes par defaut (0 0 0  0 0): 
!       on definit les 5 cotes d'apres les valeurs observees

! cotdeb
	if(cotdeb.eq.0.and.ut_sor.eq.'d') cotdeb=date(1)
	if(cotdeb.eq.0.and.ut_sor.eq.'a') cotdeb=DANN(date(1))	
	xd=cotdeb
! cotfin
	if(cotfin.eq.0.and.ut_sor.eq.'d') cotfin=date(ntot)
	if(cotfin.eq.0.and.ut_sor.eq.'a') cotfin=DANN(date(ntot))
	xf=cotfin
! dcot
        if(dcot.eq.0) dcot=0.3*(xf-xd)
	dx=dcot            
! cotydeb
	if(cotydeb.eq.0) cotydeb=1.10*ecmax
	yd=-1.5*cotydeb
	yf=cotydeb
! dcoty
        if(dcoty.eq.0) dcoty=0.3*(yf-yd)
	dy=dcoty           

c	type*,'Tendance dx,dy',dx,dy

	write(10,801) xd,xf,yd,yf,dx,dy
 801	format('psxy crono_gmt.tout -X11 -Y14',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'snWe',
             !          -R1660/2100/-49/50       -B50/10snWe
	2      ' -JX11/5 -Sc.02 -W10/0/0/255  -K > crono_gmt.ps')

	write(10,802)  ! signal de depart
 802	format('psxy -O crono_gmt.tout',
	1      ' -R -JX  -W2/0/0/255 -K >> crono_gmt.ps')
	write(10,803)  ! valeurs aberrantes supprimees
 803	format('psxy -O crono_gmt.elim -R -JX -Sc.10',
	1      ' -G255/0/255 -K >> crono_gmt.ps')
c	write(10,8030)  ! valeurs ajoutees dans les trous
c 8030	format('psxy -O crono_gmt.ajou -R -JX -Sc.05',
c	1      ' -G200/255/0 -K >> crono_gmt.ps')
	write(10,804)  ! tendance
 804	format('psxy -O crono_gmt.tend -R -JX -Sd0.05',
	1      ' -G0/0/255 -W5/0/255/0  -K >> crono_gmt.ps')

!       Titre et commentaires

	xe=xf !0.4*(xf+xd)  !/2.
	ye=yf +0.2*(yf-yd)
	write(10,805) xe, ye, sta(1:ltit), tab,monu
 805	format('pstext -O -R -JX -G0/0/255 -N -K',
	1      ' << eof >> crono_gmt.ps'/
	2      2f10.2,' 14 0 0 3 Crono_Vue Analysis of ',a,
	3    ' - Sampling time:',f6.2,' ',a/
	4      'eof')

	xe=xd+0.05*(xf-xd)
	ye=yf-0.1*(yf-yd)
	write(10,807) xe, ye, uni_var(1:lvar)
 807	format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2  2f10.2,' 12 0 0 0  Slope-corrected original series (',a,')'/
	3      'eof')

	xe=xd+0.05*(xf-xd)
	ye=yd+0.24*(yf-yd)
	write(10,808) xe, ye, uni_var(1:lvar)
 808	format('pstext -O -R -JX -G0/255/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0  Trend (',a,')'/
	3      'eof')


	xe=xd+0.05*(xf-xd)
	ye=yd+0.1*(yf-yd)

	truc=filtre       ! en annees
	if(utend.eq.'s') truc=filtre*3600.d0*24.d0*365.2422d0
	if(utend.eq.'h') truc=filtre*24.d0*365.2422d0
	if(utend.eq.'d') truc=filtre*365.2422d0
	if(utend.eq.'w') truc=filtre*365.2422d0/7.d0
	if(utend.eq.'m') truc=filtre*12.d0
!        0         0         0         0         0         0         |72
	write(10,809) 
c	3    xe+0.53*(xf-xd), ye,               taumin,aruc,
	3    xe,             ye-0.08*(yf-yd), biastend,uni_var(1:lvar),
	4    xe+0.53*(xf-xd), ye-0.08*(yf-yd), truc,utend
 809	FORMAT('pstext -O -R -JX -G0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
c	3 2f10.2,' 12 0 0 0 Min Allan var. at',f7.2,1x,a/
	3 2f10.2,' 10 0 0 0 Bias:',f7.1,1x,a/
	4 2f10.2,' 10 0 0 0 Filter length :',f7.2,1x,a/
	5 'eof')
	write(10,8090) 
	1             xe,ye,pentend,spentend,uni_var(1:lvar),ut_sor
 8090	FORMAT('pstext -O -R -JX -G255/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2 2f10.2,' 10 0 0 0 Slope:',f8.3,' +-',f7.3,1x,a,'/',a/
	5 'eof')

!       ---------------------------
!       CADRE Ts2: Saisonnier(s) A/B
!       ---------------------------

	yd=yd/1.5

	xe=xd+0.05*(xf-xd)
	ye=yf-0.2*(yf-yd)

	do 815 I=1,NS

	write(10,810) I
 810	format('################'/'echo "Saisonnier',i2,'"')

	IF (I.eq.1) THEN
	   write(10,811) xd,xf,yd,yf,dx,dy
 811	   format('psxy -O crono_gmt.saisA -Y-4',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'snWe',
	2      ' -JX11/4 -W10/0/255/0 -K >> crono_gmt.ps')

	   truc=cycla                               ! annees
	   if(ut_sp.eq.'d') truc=truc*365.2422      ! jours
	   if(ut_sp.eq.'h') truc=truc*365.2422*24.  ! heures

	   write(10,813) xe,ye, truc,ut_sp,uni_var(1:lvar)
 813	   format('pstext -O -P -R -JX -G0/255/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0 Periodic:',f6.2,1x,a,' (',a,')'/
	3      'eof')

	ENDIF

	IF (I.eq.2) THEN 
	   write(10,812) xd,xf,yd,yf,dx,dy
 812	   format('psxy -O crono_gmt.saisB -Y-4',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'snWe',
	2      ' -JX11/4 -W10/0/255/0 -K >> crono_gmt.ps')

	   truc=cyclb                                ! annees
	   if(ut_sp.eq.'d') truc=cyclb*365.2422      ! jours
	   if(ut_sp.eq.'h') truc=cyclb*365.2422*24.  ! heures
	   write(10,813) xe,ye, truc,ut_sp,uni_var(1:lvar)
	ENDIF

 815	continue

!       ---------------
!       CADRE Ts3: Reste
!       ---------------

	write(10,816) 
 816	format('################'/'echo "Reste"')

	write(10,817) xd,xf,yd,yf,dx,dy
 817	format('psxy -O crono_gmt.rest -Y-4 -JX11/4',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'SnWe',
	2      ' -Ey.005/.1/0/0/255 -K >> ',
	3      'crono_gmt.ps'/
	4      'psxy -O crono_gmt.rest -P -R -JX -W10/0/255/0',! -Sc.03 
	5      ' -K >> crono_gmt.ps')

	if(ut_sor.eq.'a') 
	1    write(10,8170) 0.5*(xd+xf),yd-0.3*(yf-yd)
 8170	format('pstext -O -P -R -JX -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 12 0 0 6  Date (years)'/
	3      'eof')

	if(ut_sor.eq.'d') 
	1    write(10,8171) 0.5*(xd+xf),yd-0.3*(yf-yd)
 8171	format('pstext -O -P -R -JX -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 12 0 0 6  Date (MJD)'/
	3      'eof')

	xe=xd+0.05*(xf-xd)
	ye=yf-0.15*(yf-yd)
	write(10,818) xe,ye, uni_var(1:lvar)
 818	format('pstext -O -P -R -JX -G0/255/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 12 0 0 0  Irregular (',a,')'/
	3      'eof')

	xe=xf-0.05*(xf-xd)
	if(kpo.eq.1) write(10,8180) xe,ye
 8180	format('pstext -O -P -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 10 0 0 3  Original error bars'/
	3      'eof')

	xe=xd+0.05*(xf-xd)
	ye=yd+0.1*(yf-yd)
	write(10,819) xe, ye, rms_rest, uni_var(1:lvar)
 819	format('pstext -O -R -JX -G0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0 Std Dev:',f6.1,1x,a/
	3      'eof')
	if(chi_rest.ne.0) write(10,8190) 
	1             xe+0.55*(xf-xd), ye, chi_rest
 8190	format('pstext -O -R -JX -G0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0 Chi^2:',f8.2/
	3      'eof')

!       -----------------------
!       CADRE Sp3: Spectre reste
!       -----------------------

	write(10,820) 
 820	format('################'/'echo "Spectre Reste"')

	xd=-.5/persup(2)                  ! c/jours
	if(ut_sp.eq.'h') xd=xd/24.        ! c/heures
	if(ut_sp.eq.'a') xd=xd*365.2422   ! c/annees

	xf=1.1/perinf(2)                  ! c/jours
	if(ut_sp.eq.'h') xf=xf/24.        ! c/heures
	if(ut_sp.eq.'a') xf=xf*365.2422   ! c/annees

	yd=-0.2*1.5*cotsp
	yf=1.5*cotsp

	dx=0.3*(xf-xd)
	dy=0.3*(yf-yd)

	write(10,821) xd,xf,yd,yf,dx,dy
 821	format('psxy -O crono_gmt.sp_rest -X-7 -Y1 -JX5/2.8',
	1      ' -R',2('/',f10.3),2('/',f10.4),' -B',f9.4,'/',f9.4,
	2      'SnWe  -K >> crono_gmt.ps'/
	3      'psxy -O crono_gmt.sp_rest -R -JX',
	2      ' -Sc.01 -Ey.01/.1/0/255/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*

	write(10,822) 
 822	format('psxy -O crono_gmt.sp_rest -R -JX -W10/0/0/0 -K',
	1      ' >> crono_gmt.ps')

	xe=0.5*(xf+xd)
	ye=yf-0.15*(yf-yd)
	write(10,823) xe,ye,ut_sp, 
	1             xe,yd+0.13*1.5*cotsp,uni_var(1:lvar)
 823	format('pstext -O -R -JX -G0/0/0 -N -K << eof >> crono_gmt.ps'/
	2      2f11.4,' 10 0 0 6 Periodogram (cycles/',a,')'/
	2      2f11.4,' 10 0 0 6 Irregular (',a,')'/
	3      'eof')

c	xe=xd
c	ye=xf
	write(10,824) xd,xf
 824	format('psxy -O -R -JX -W5/0/0/0  -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      f9.2,'  0.'/f9.2,'  0.'/
	3      'eof')

	xper1=perinf(2)                         ! jours
	if(ut_sp.eq.'h') xper1=xper1*24.        ! heures
	if(ut_sp.eq.'a') xper1=xper1/365.2422   ! annees
	x1=1./xper1

	xper3=persup(2)                         ! jours
	if(ut_sp.eq.'h') xper3=xper3*24.        ! heures
	if(ut_sp.eq.'a') xper3=xper3/365.2422   ! annees
	x3=1./xper3

	x2=x3+(x1-x3)/3.
	xper2=1./x2

	x4=x3+(x1-x3)*2./3.
	xper4=1./x4

	write(10,8540) x1, y0+dy, xper1,ut_sp,
	1              x2, y0+dy, xper2,ut_sp,
	1              x3, y0+dy, xper3,ut_sp,
	1              x4, y0+dy, xper4,ut_sp
 8540	format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	3      'eof')

!       ------------------------------------------
!       CADRE Sp2: Variations amplitude cyclique(s)
!       ------------------------------------------

	do 845 I=NS,1,-1

	write(10,830) pcy(I),usais
 830	format('################'/
	1 'echo "Amplitude cyclique',f10.2,' ',a,'"')

	   xd=cotdeb
	   xf=cotfin
	   dx=2.*dcot

	   yd= 0.
	   yf= 2.*cotamp
	   dy=0.3*(yf-yd)

	   IF (I.eq.1) THEN
	      write(10,831) xd,xf,yd,yf,dx,dy
 831	      format('psxy -O crono_gmt.cy_saisA1 -Y4 -JX5/2.8'
	1            ' -R',2('/',f9.3),2('/',f9.3),
	2	     ' -B',f8.4,'/',f8.4,'SnWe',
	3            ' -Sc.01 -K >> crono_gmt.ps'/

	1	  'psxy -O crono_gmt.cy_saisA1 -R -JX'
	2	  ' -Ey.01/.1/0/255/255 -G0/255/255 -K',
	3	  ' >> crono_gmt.ps') 

	      write(10,834) 
 834	      format('psxy -O crono_gmt.cy_saisA1 -R -JX',
	1         ' -W10/0/255/255 -K >> crono_gmt.ps'/

	1	   'psxy -O crono_gmt.cy_saisA2 -R -JX',
	2         ' -Sc.01 -Ey.01/.1/200/100/0  -W10/200/100/0 -K',
	3         ' >> crono_gmt.ps'/

	1	  'psxy -O crono_gmt.cy_saisA2 -R -JX',
	2         ' -W10/200/100/0 -K >> crono_gmt.ps')

	      xe=xd+0.1*(xf-xd)
	      ye=yf-0.15*(yf-yd)
	      write(10,835) xe,ye,uni_var(1:lvar)
 835	      format('pstext -O -R -JX -G0/0/0 -N -K << eof'
	1	     ' >> crono_gmt.ps'/
	2      2f15.4,' 10 0 0 0 Amplitudes (',a,')'/
	3      'eof')

	      truc=cycla                                ! annees
	      if(ut_sp.eq.'d') truc=cycla*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=cycla*365.2422*24.  ! heures
	      write(10,836) xe,ye-0.20*(yf-yd),truc,ut_sp
 836	      format('pstext -O -R -JX -G0/255/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f15.4,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')

	      truc=0.5*cycla                                ! annees
	      if(ut_sp.eq.'d') truc=0.5*cycla*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=0.5*cycla*365.2422*24.  ! heures
	      write(10,8361) xe,ye-0.35*(yf-yd),truc,ut_sp
 8361	      format('pstext -O -R -JX -G200/100/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f9.2,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')
!        0         0         0         0         0         0         |72
	   ENDIF

	   IF (I.eq.2) THEN
	      write(10,837) xd,xf,yd,yf,dx,dy
 837	      format('psxy -O crono_gmt.cy_saisB1 -Y4 -JX5/2.8'
	1            ' -R',2('/',f9.3),2('/',f9.3),
	2	     ' -B',f8.4,'/',f8.4,'SnWe',
	3            ' -Sc.01 -K >> crono_gmt.ps'/

	1	  'psxy -O crono_gmt.cy_saisB1 -R -JX'
	2	  ' -Ey.01/.1/0/255/255 -G0/255/255 -K',
	3	  ' >> crono_gmt.ps')

	      write(10,838) 
 838	      format('psxy -O crono_gmt.cy_saisB1 -R -JX',
	1         ' -W10/0/255/255 -K >> crono_gmt.ps'/

	1	  'psxy -O crono_gmt.cy_saisB2 -R -JX',
	2         ' -Sc.01 -Ey.01/.1/200/100/0  -W10/200/100/0 -K',
	3         ' >> crono_gmt.ps'/

	1	   'psxy -O crono_gmt.cy_saisB2 -R -JX',
	2         ' -W10/200/100/0 -K >> crono_gmt.ps')


	      xe=xd+0.1*(xf-xd)
	      ye=yf-0.15*(yf-yd)
	      write(10,835) xe,ye,uni_var(1:lvar)

	      truc=cyclb                                ! annees
	      if(ut_sp.eq.'d') truc=cyclb*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=cyclb*365.2422*24.  ! heures
	      write(10,8360) xe,ye-0.20*(yf-yd),truc,ut_sp
 8360	      format('pstext -O -R -JX -G0/255/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f9.2,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')

	      truc=0.5*cyclb                                ! annees
	      if(ut_sp.eq.'d') truc=0.5*cyclb*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=0.5*cyclb*365.2422*24.  ! heures
	      write(10,8362) xe,ye-0.35*(yf-yd),truc,ut_sp
 8362	      format('pstext -O -R -JX -G200/100/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f9.2,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')
	   ENDIF

 845	continue

!       --------------------------
!       CADRE Sp1: Spectre tendance
!       --------------------------

	write(10,850) 
 850	format('################'/'echo "Spectre Tendance"')

	xd=0.5/persup(1)                  ! c/jours   
	if(ut_sp.eq.'h') xd=xd/24.        ! c/heures
	if(ut_sp.eq.'a') xd=xd*365.2422   ! c/annees

	xf=1.1/perinf(1)                  ! c/jours
	if(ut_sp.eq.'h') xf=xf/24.        ! c/heures
	if(ut_sp.eq.'a') xf=xf*365.2422   ! c/annees

	yd=-0.2*1.5*cotst
	if(yd.eq.0) yd=-0.2*1.5*cotsp  ! on prend la valeur du spectre de l'irregulier
	yf=1.5*cotst
	if(yf.eq.0) yf=1.5*cotsp       ! on prend la valeur du spectre de l'irregulier

	dx=0.3*(xf-xd)
	dy=0.3*(yf-yd)

	IF (kspt.eq.1) THEN

	write(10,851) xd,xf,yd,yf,dx,dy
 851	format('psxy -O crono_gmt.sp_tend -Y4 -JX5/2.8',
	1      ' -R',2('/',f10.3),2('/',f10.3),' -B',f9.4,'/',f9.4,'SnWe',
	2      ' -Sc.01 -Ey.01/.1/0/255/0 -K >> crono_gmt.ps')

	   write(10,852) 
 852	   format('psxy -O crono_gmt.sp_tend -R -JX -W10/0/0/0 -K',
	1      ' >> crono_gmt.ps')

	   xe=0.5*(xf+xd)
	   ye=yf-0.12*(yf-yd)
	   write(10,8233) xe, ye, ut_sp, 
	1              xe, yd+0.15*1.5*cotst, uni_var(1:lvar)
 8233	   format('pstext -O -R -JX -G0/0/0 -N -K << eof >> crono_gmt.ps'/
	2      2f11.4,' 10 0 0 6 Periodogram (cycles/',a,')'/
	2      2f11.4,' 10 0 0 6 Trend (',a,')'/
	3      'eof')

c	   xe=xd
c	   ye=xf
	   write(10,853) xd,yf
 853	   format('psxy -O -R -JX -W5/0/0/0 -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      f12.5,'  0.'/f12.5,'  0.'/
	3      'eof')

	   xper1=perinf(1)                       ! jours
	   if(ut_sp.eq.'h') xper1=xper1*24.      ! heures
	   if(ut_sp.eq.'a') xper1=xper1/365.2422 ! annees
	   x1=1./xper1

	   xper3=persup(1)                       ! jours
	   if(ut_sp.eq.'h') xper3=xper3*24.      ! heures
	   if(ut_sp.eq.'a') xper3=xper3/365.2422 ! annees
	   x3=1./xper3

	   x2=x3+(x1-x3)/3.
	   xper2=1./x2

	   x4=x3+(x1-x3)*2./3.
	   xper4=1./x4

	   write(10,8540) x1, y0, xper1,ut_sp,
	1              x2, y0, xper2,ut_sp,
	1              x3, y0, xper3,ut_sp,
	1              x4, y0, xper4,ut_sp

	   xe=0.5*(xf+xd)
	   ye=yf+0.3*(yf-yd)
	   write(10,854) xe,ye+0.25*(yf-yd), xe,ye
 854	   format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 14 0 0 6 Spectral content'/
	2      2f12.4,' 12 0 0 6 Least square analyses'/
	3      'eof')

	ELSE

	   write(10,8510) 
 8510	   format('psxy -O -Y4 crono_gmt.sp_rest -JX5/2.8',
	1      ' -R/0/1/-1001/-1000 -B/7/7snwe -K >> crono_gmt.ps'/
	2      'pstext -O -R -JX -G0/255/0 -N -K << eof >> crono_gmt.ps'/
	3      '.5 -1000.4 10 0 0 6 Low frequency spectrum'/
	4      '.5 -1000.6 10 0 0 6 not available'/
	5      'eof'/
	6      'pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      '.5 -999.45 14 0 0 6 Spectral content'/
	2      '.5 -999.70 12 0 0 6 Least square analyses'/
	3      'eof')

	ENDIF


!       ----------------------------
!       CADRE Av1: Stabilite tendance
!       ----------------------------

	write(10,860) 
 860	format('################'/'echo "Stabilite Tendance"')

	xd=kxv-2.5    ! centre sur tau median
	xf=kxv+2.5

	yd=kyv-2.5    ! centre sur variance mediane
	yf=kyv+2.5

	dx= 1.
	dy= 1.

	write(10,861) xd,xf,yd,yf,dx,dy
 861	format('psxy -O crono_gmt.varp_tend -X20.5 -JX2.5/2.5'
	1      ' -R',2('/',f10.2),2('/',f10.2),' -B',f9.4,'/',f9.4,'SnWe',
	1      ' -Sd0.2 -W10/0/255/0 -K >> crono_gmt.ps')

	write(10,862)
 862	format('psxy -O crono_gmt.varp_tres -R -JX -Sd0.2',
	1      ' -W10/0/0/255 -K >> crono_gmt.ps')

	write(10,863) 0.5*(xd+xf), yf+4.5,
	1             0.5*(xd+xf), yf+3.5,
	1             0.5*(xd+xf)-4.5, yf+3.5,
	1             0.5*(xd+xf)-2.2, yf+1.0,
	2             0.5*(xd+xf)+1.3, yf+1.0
!        0         0         0         0         0         0         *72*
 863	format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 14 0 0 6 Allan variance'/
	2      2f10.2,' 14 0 0 6 Analysis'/
	2      2f10.2,' 8 -45 0 0  White noise'/
	2      2f10.2,' 8   0 0 0  Flicker noise'/
	2      2f10.2,' 8  45 0 0  Random walk'/
	3      'eof')

	write(10,865) xd-2.0, yd,
	1             xd-.5, yd-2.1, ut_sp
 865	format('pstext -O -R -JX -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 8  90 0 0  log (Allan variance)'/
	2      2f10.2,' 8   0 0 0  log (Sampling time [',a1,'])'/
	3      'eof')

	write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)
 8650	format('pstext -O -R -JX -G0/0/0 -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 6  0 0 5  100 ',a/
	2      2f10.2,' 6  0 0 5  10 ',a/
	2      2f10.2,' 6  0 0 5  1 ' ,a/
	2      2f10.2,' 6  0 0 5  .1 ',a/
	2      2f10.2,' 6  0 0 5  .01 ',a/
	3      'eof')

        x1=kxv
        xper1=10**x1
        x2=kxv-1
        xper2=10**x2
        x3=kxv+1
        xper3=10**x3
        x4=kxv+2
        xper4=10**x4

	write(10,8651) x1, yd+.05, xper1,ut_sp,
	1              x2, yd+.05, xper2,ut_sp,
	1              x3, yd+.05, xper3,ut_sp,
	1              x4, yd+.05, xper4,ut_sp
 8651	format('pstext -O -R -JX -G0/0/0 -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	3      'eof')

!       -------------------------------
!       CADRE Av2: Stabilite Cyclique(s)
!       -------------------------------

	write(10,870) 
 870	format('################'/'echo "Stabilite Cyclique(s)"')

	DO 879 I=1,NS   ! NS: nb de composantes cycliques

	   IF (I.eq.1) THEN
	      xd=kxa-2.5
	      xf=kxa+2.5
	      yd=kav-2.5	! centre sur variance mediane
	      yf=kav+2.5
	   ELSE
	      xd=kxb-2.5
	      xf=kxb+2.5
	      yd=kbv-2.5	! centre sur variance mediane
	      yf=kbv+2.5
	   ENDIF

	   IF (I.eq.1) THEN
	      write(10,871) xd,xf,yd,yf,dx,dy
 871	      format('psxy -O crono_gmt.varp_ampA2 -Y-4 -JX2.5/2.5'
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f8.3,'/',f8.3,'SnWe',
	1      ' -Sd0.2 -W10/200/100/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*

	      write(10,872)
 872	      format('psxy -O crono_gmt.varp_ampA1 -R -JX -Sd0.2',
	1      ' -W10/0/255/255 -K >> crono_gmt.ps')

	      write(10,865)  xd-2.0, yd, xd-.5, yd-2.1,ut_sp
	      write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)

              x1=kxv
              xper1=10**x1
              x2=kxv-1
              xper2=10**x2
              x3=kxv+1
              xper3=10**x3
              x4=kxv+2
              xper4=10**x4

	      write(10,8651) x1, yd+.05, xper1,ut_sp,
	1              x2, yd+.05, xper2,ut_sp,
	1              x3, yd+.05, xper3,ut_sp,
	1              x4, yd+.05, xper4,ut_sp

	   ENDIF

	   IF (I.eq.2) THEN
	      write(10,873) xd,xf,yd,yf,dx,dy
 873	      format('psxy -O crono_gmt.varp_ampB2 -Y-4 -JX2.5/2.5'
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f8.3,'/',f8.3,'SnWe',
	1      ' -Sd0.2 -W10/200/100/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*

	      write(10,874)
 874	      format('psxy -O crono_gmt.varp_ampB1 -R -JX -Sd0.2',
	1      ' -W10/0/255/255 -K >> crono_gmt.ps')

	      write(10,865)  xd-2.0, yd, xd-.5, yd-2.1,ut_sp
	      write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)
	   ENDIF

 879	continue


!       -------------------------
!       CADRE Av3: Stabilite reste
!       -------------------------

	xd=kxv-2.5
	xf=kxv+2.5
	yd=kyv-2.5    ! centre sur variance mediane
	yf=kyv+2.5

	write(10,880) 
 880	format('################'/'echo "Stabilite Reste"')

	write(10,881) xd,xf,yd,yf,dx,dy
 881	format('psxy -O crono_gmt.varp_rest -Y-4 -JX2.5/2.5'
	1      ' -R',2('/',f9.3),2('/',f9.3),' -B',f8.3,'/',f8.3,'SnWe',
	1      ' -Sd0.2 -W10/0/255/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*

	write(10,882)
 882	format('psxy -O crono_gmt.varp_tres -R -JX -Sd0.2',
	1      ' -W10/0/0/255 -K >> crono_gmt.ps')

	write(10,865) xd-2.0, yd, xd-.5, yd-2.1,ut_sp
	write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)

        x1=kxv
        xper1=10**x1
        x2=kxv-1
        xper2=10**x2
        x3=kxv+1
        xper3=10**x3
        x4=kxv+2
        xper4=10**x4

	write(10,8651) x1, yd+.05, xper1,ut_sp,
	1              x2, yd+.05, xper2,ut_sp,
	1              x3, yd+.05, xper3,ut_sp,
	1              x4, yd+.05, xper4,ut_sp

!       -------------------------
!       On termine le fichier gmt
!       -------------------------

	write(10,895)
 895	format('pstext -O -R -JX -G0/0/0 -N',
	1      ' << eof >> crono_gmt.ps'/'eof'/
	2      'ps2epsi crono_gmt.ps crono_gmt.eps'/
	3      'echo "gs crono_gmt.ps"'/'## Fin ##')

	Close (10)

!       On remplace les blancs parasites par des 0

	open(10,status='old',readonly,file='crono_gmt.s')
	open(11,status='unknown',file='crono_gmt.sh')

 900	read(10,901,end=1000) chaine
 901	format(a)
	lch=300

	do 903 I=lch,1,-1
	   if(chaine(I:I).ne.' ') go to 904
 903	continue
 904	lch=I
c	type*,lch
c	if(lch.gt.140)
c	1    type*,'crono_gmt.s:',lch,' - ',chaine(1:40)

	DO L=1,10

	do 910 I=2,lch
	   IF (chaine(I:I).eq.'/'.or.chaine(I-1:I).eq.'-B') THEN
	      k=0
 905	      k=k+1
	      IF (chaine(I+k:I+k).eq.' ') THEN
c		 chaine(I+k:I+k)='0'
		 do 908 J=I+k,lch
		    chaine(J:J)=chaine(J+1:J+1)
 908		 continue
		 go to 905
	      ENDIF
	   ENDIF
 910	continue

	ENDDO

 	write(11,911) (chaine(I:I),I=1,lch)
 911	format(132a1)
	go to 900

 1000	continue

	type*,'-- Suite: chmod +x crono_gmt.sh; crono_gmt.sh;',
	1     'gs crono_gmt.ps  --'

	Close (10)
	Close (11)

	Close (16)

	stop
        end
!FIN

	include crono.f

	include allan.f
 	include elfil.f
 	include elfil2.f
	include elcopo.f
	include elpond.f
	include elsais.f
	include eltend.f
	include mcgauss.f
	include netcent.f
	include spfil.f
	include varbruit.f

	include binsup.f
	include call_chi.f
	include chi2.f
	include diversig.f
	include tridin.f
	include valmed.f
