	FUNCTION DIVERSIG(R,S,NJ,ICHOIX,RR)

c------------------------------------------------------------------------
c	Calcul d'un certain nombre de statistiques sur une liste
c	(R(I),I=1,NJ), munies des incertitudes S(I)
c	On selectionne la statistique par ICHOIX :

c	1 : P (m.q. pond. des residus / m.q. des sigmas)
c		C'est le nombre utilise comme facteur d'echelle.
c	2 : R moyenne de [(residu / sigma)**2]
c		 C'est le "faux Chi2", ou Goodness-of-fit.
c	3 : C (correlation centrale de R et S)
c	4 : Moyenne quadratique ponderee des R(I) (poids=1/S(I)**2)
c	5 : Moyenne quadratique des R(I)
c	6 : moyenne ponderee de R(I) (poids: S(I)**-2)
c	7 : moyenne de R(I)
c	8 : mediane de R(I) pondere (poids: S(I)**-2)
c	9 : mediane de R(I)

c	Dans les cas 6 a 9, la fonction rend les ecarts
c	R(I)-DIVERSIG dans le tableau RR(I)

c					Auteur: M. Feissel, 1989-2001
c------------------------------------------------------------------------

	Implicit none
	
	Real*4 R(NJ),S(NJ),RR(NJ),RP(NJ),VALMED,DIVERSIG,
     .	       rasig,repoi,resig,recar,remoy,rmoyp    !,CA(1)
	Integer*4 NJ,ICHOIX,L

	rasig=0.
	repoi=0.
	resig=0.
	recar=0.
	remoy=0.
	rmoyp=0.
	do 1226 L=1,nj
	rasig=rasig+S(L)**2
	repoi=repoi+1./(S(L)**2)
	resig=resig+(R(L)/S(L))**2
	recar=recar+R(L)**2
	remoy=remoy+R(L)
	rmoyp=rmoyp+R(L)/(S(L)**2)
	RP(L)=R(L)/(S(L)**2)
!	type*,L,R(L),RP(L)
 1226	continue
      DIVERSIG=0
	if (ICHOIX.eq.1) DIVERSIG=SQRT((resig/repoi)/(rasig/NJ))
	if (ICHOIX.EQ.2) DIVERSIG= resig/(NJ-1)		     	! janv 1991
 
c        IF (ichoix.eq.3) THEN             			! avrl 1991
c           CALL CORREL(r,s,nj,0,ca,1)       
c           DIVERSIG=ca(1)                    
c           RETURN                           
c        ENDIF            

	if (ICHOIX.EQ.4) DIVERSIG=SQRT(resig/repoi)		! juin 1989
	if (ICHOIX.EQ.5) DIVERSIG=SQRT(recar/NJ)	        ! juin 1989

	if (ICHOIX.EQ.6) DIVERSIG=rmoyp/repoi			! janv 1991
	if (ICHOIX.EQ.7) DIVERSIG=remoy/NJ			! janv 1991

      	if (ICHOIX.EQ.8) DIVERSIG=VALMED(RP,NJ)			! sept 2001
      	if (ICHOIX.EQ.9) DIVERSIG=VALMED(R,NJ)			! sept 2001

	IF (ICHOIX.ge.6) THEN
	   do 1230 L=1,NJ
	      RR(L)=R(L)-DIVERSIG
 1230	   continue
	ENDIF

	RETURN
	END

