!       f77  tot_crono_vue.f -o crono_vuerm crono_vue.o
          
!       Lecture de la serie chronologique
!       Transmission a crono.f:
!                     date MJD, valeur (seri de ELSER), sigma (eventuellement 0)
!       Retour de chrono.f (memes unite qu'a l'aller):
!                     Commons ELSER, SPECTRES, CYCL, STAT
!       Sorties pour les graphique: exclusivite des sorties, sauf write(16,...
!       Tous les logiciels utilises sont susceptibles d'ecrire dans le .echo (16)
!       Gere les changements d'unite en sortie/l'entree
          
!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002
          
	Implicit none
	Integer*4   NF,Nsp,Ncc,Nst
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nsp=1000)   ! Nb de pts du spectre (spfil.f)
	Parameter (Ncc=1000)   ! Nb de cycles sur la duree totale
	Parameter (Nst=1000)   ! Nb de variances d'Allan (common STAT)
          
          
	Character*1  monu,ut_ent,ut_sor,ut_sp,utend,usais,
	1            undeux(2)
	Character*4  resu(5),avsan(2)
	Character*31  sta
      	Real*8       truc,tab,tabul
      	Real*4       factar,cotdeb,cotfin,dcot,cotydeb,dcoty,
c	1            tab,tabul,
	2            filtre,cycla,cyclb,BINSUP,
	3            sercot(NF),sercor(NF),cotst,cotsp,cotamp
	Integer*4    I,J,k,kpo,ks,kspt,L,lpsb,lvar,ltit,ncot,ncor
          
!       Declarations pour transferer les donnees a CRONO
          
	Character*6  uni_var                 ! nom de l'unite en sortie
      	Real*8       date,djou               ! dates MJD
      	Real*4       tref,geri,ajou          ! tref: numero
	Integer*4    njou
	COMMON/DONNEES/date(NF),uni_var,tref(NF),geri(NF)
	COMMON/AJOUS/djou(NF),ajou(NF),njou
          
!       Declarations pour l'interface avec ELFIL
          
      	Real*4 BP,BI,belim,DATDEP,SERI,TEND,SAIS,SAISb,REST
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),saisB(NF),REST(NF)
          
!       Declarations pour l'interface avec SPFIL
          
      	Real*4       frq,amp,samp,pt,perinf,persup,
	1            x1,xper1,x2,xper2,x3,xper3,x4,xper4
	Integer*4    NR
	COMMON/SPECTRES/frq(Nsp,2),amp(Nsp,2),samp(Nsp,2),NR(2),pt(NF)
	1               ,perinf(2),persup(2)
          
!       Pour recevoir les variations du cyclique
          
	Real*8    datecy
	Real*4    cyc,scyc
	Integer*4 ncy,NS
	Common/CYCL/datecy(Ncc,2),cyc(Ncc,2,2),scyc(Ncc,2,2),ncy(2),NS
!        0         0         0         0         0         0         *72*
          
!       Pour recevoir les stat de NETCENT
          
      	Real*8      dlim
      	Real*4      elim,centre,ecmax,fac
	Integer*4   nlim
	COMMON/ELIMS/dlim(NF),elim(NF),nlim,centre,ecmax,fac
          
!       Pour recevoir les stat de VARBRUIT
          
	Real*4       biastend,pentend,spentend,pent,sent,pv,
	1            rms_rest,chi_rest,tz,vz,pcy,cab,pentre
	Integer*4    nvz,kab
	Common/STAT/pcy(3),kab,biastend,pentend,spentend,pent(7),sent(7),
     .              tz(Nst,7),vz(Nst,7),nvz(7),rms_rest,chi_rest,pv(NF)
!       1: tend+rest; 2:tend;  3: rest;
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2
          
!       Pour DIVERSIG
          
      	Real*4      DIVERSIG,vsr(nst),vpr(nst),vrr(nst)
          
!       Pour la sortie crono_gmt.sh
          
	Character*300  chaine
	Real*4         xd,xf,yd,yf,y0,dx,dy,xe,ye
	Integer*4      lch,kx,kyv,kav,kbv,kxv,kxa,kxb
          
          
	data avsan/'sans','avec'/
	data undeux/'A','B'/
	data resu/'Tout','Tend','CycA','Rest','CycB'/
          
	Real*8    DMJD,DAN,DMJW,GPW,DANN,DJD
!	DMJW(GPW)=51548.5d0+(GPW-1043.0d0)*7.d0       ! GPS weeks => MJD central
	DMJW(GPW)=51545.d0+(GPW-1043.0d0)*7.d0       ! GPS weeks => MJD central
	DMJD(DAN)=51544.03d0+(DAN-2000.0d0)*365.2422d0 ! Annees => MJD
	DANN(DJD)=2000.0d0+(DJD-51544.03d0)/365.2422d0 ! MJD => Annees
          
	open(1,status='old',readonly,file='crono_vue.dat')
	open(3,status='old',readonly,file='crono_vue.serie')	
          
	open(16,status='unknown',file='crono_vue.echo')
          
          
!                   +- ----------------------------------+
!                   | Lecture des instructions d'analyse |
!                   +- ----------------------------------+
          
!       Unite de temps et intervalle tabulaire en entree
!       ------------------------------------------------
          
	read(1,*) monu,tab
!       Ex.: 's' 1 ; 'h' 1 ; 'd' 5; 'w' 1 ; 'm' 1 ; 'a' .20 ;
!        0         0         0         0         0         0         |72	
	IF (monu.ne.'s'.and.monu.ne.'h'.and.monu.ne.'d'.and.monu.ne.'w'
	1  .and.monu.ne.'m'.and.monu.ne.'a') THEN
	   type*,'** ERREUR: Ligne 1 de crono_gmt.dat:',
	1  ' unite tabulaire <',monu,'> non reconnue'
	   type*,'** On accepte: ''s'', ''h'', ''d'', ''w'''
	1	,' ''m'', ''a'' '
	   STOP
	ENDIF
          
c	type*,'1'
          
!       Dates, intervalle tabulaire => annees
          
	if(monu.eq.'s') tabul= tab/(3600.d0*24.d0*365.2422d0)
	if(monu.eq.'h') tabul= tab/(24.d0*365.2422d0)
	if(monu.eq.'d') tabul= tab/365.2422d0
	if(monu.eq.'w') tabul= tab*7.d0/365.2422d0
	if(monu.eq.'m') tabul= tab/12.d0
	if(monu.eq.'a') tabul= tab
          
!       Unite de temps en ENTREE ('d'=MJD;'a'=annees;'w'=GPS week)
!       Unite de temps en SORTIE ('d'=MJD;'a'=annees)
!       ----------------------------------------------------------
          
	read(1,*)  ut_ent, ut_sor ,ut_sp
          
c	type*,'2'
          
	IF (ut_ent.ne.'d'.and.ut_ent.ne.'a'.and.
	1   ut_ent.ne.'w') THEN
	   type*,'** ERREUR: Ligne 2 de crono_gmt.dat:',
	1	' unite de temps en entree <',
	1  ut_ent,'> non prevue'
	   type*,'** On accepte les datations ''d'' (MJD),'
	1	, ' ''a'' (annees) et ''w'' (GPS week)'
	   STOP
	ENDIF
          
	IF ( ut_sor.ne.'d'.and.ut_sor.ne.'a') THEN
	   type*,'** ERREUR: Ligne 2 de crono_gmt.dat:',
	1	' unite de temps en sortie <',
	1  ut_sor,'> non prevue'
	   type*,'** On accepte les datations ''d'' (MJD) et'
	1	, ' ''a'' (annees)'
	   STOP
	ENDIF
          
	IF ( ut_sp.ne.'h'.and.
	1    ut_sp.ne.'d'.and.ut_sp.ne.'a') THEN
	   type*,'** ERREUR: Ligne 2 de crono_gmt.dat:',
	1	' unite de temps spectres <',
	1  ut_sp,'> non prevue'
	   type*,'** On accepte les datations ''h'' (heures),'
	1	, ' ''d'' (MJD) et ''a'' (annees)'
	   STOP
	ENDIF
          
!       Cotes deb-fin des dates a tracer et intervalle des marques
!       (si = 1ere et dern date: 0 0 0)
!       -----------------------------------------------------
          
	read(1,*) cotdeb,cotfin,dcot
          
c	type*,'3'
          
!        Nom de la variable en SORTIE (max a6),
!        facteur multiplicatif a appliquer a l'unite ENTREE
!       -----------------------------------------------------
          
	read(1,*) uni_var, factar
!'cm' 10.   Nom_ variable en SORTIE, fact. mult. a appliquer a l'unite ENTREE
          
c	type*,'4'
          
!       On ne conserve que les caracteres utiles (= non vides a gauche)
	do L=6,1,-1
	   lvar=L
	   if(uni_var(L:L).ne.' ') go to 55
	enddo
 55	continue
          
!       |cote max +-y|, a tracer et intervalle des marques
!       (si = 1ere et dern date: 0 0)
!       -----------------------------------------------------
          
	read(1,*) cotydeb,dcoty
          
c	type*,'5'
          
!       Largeur filtre tendance (unite de tps: 's'; 'h';'d';'w';'m';'a')
!       ----------------------------------------------------------------
          
	read(1,*) utend,filtre
          
c	type*,'6'
          
	IF (utend.ne.'s'.and.utend.ne.'h'.and.utend.ne.'d'.and.
	1   utend.ne.'w'.and.utend.ne.'m'.and.utend.ne.'a') THEN
	   type*,'** ERREUR: Ligne 5 de crono_gmt.dat: ',
	1	' unite de temps pour filtre',
	1  'tendance <',utend,'> non reconnue'
	   type*,'** On accepte: ''s'',  ''h'', ''d'', ''w''',
	1	' ''m'', ''a'' '
	   STOP
	ENDIF
          
c	if(utend.eq.ut_ent) limp=(filtre/tab)+0.5
          
!       => filtre en annees
          
	if(utend.eq.'s') filtre= filtre/(3600.d0*24.d0*365.2422d0)
	if(utend.eq.'h') filtre= filtre/(24.d0*365.2422d0)
	if(utend.eq.'d') filtre= filtre/365.2422d0
	if(utend.eq.'w') filtre= filtre*7.d0/365.2422d0
	if(utend.eq.'m') filtre= filtre/12.d0
          
	write(6,203) filtre
	write(16,203) filtre
 203	format(' Filtre tendance',f10.4,' a')
          
!       => filtre nombre de points
          
	limp=0.5+(filtre/tabul)
	lpair=limp
          
!       Deux valeurs de cycle (unite de tps: 's'; 'h';'d';'m';'a')
!       -----------------------------------------------------
          
	read(1,*) usais,cycla,cyclb,cab
          
c	type*,'7'
          
	IF (usais.ne.'s'.and.usais.ne.'h'.and.usais.ne.'d'.and.
	1   usais.ne.'w'.and.usais.ne.'m'.and.usais.ne.'a') THEN
	   type*,'** ERREUR: Ligne 6 de crono_gmt.dat: ',
	1	' unite periodes cycliques <',
	1  usais,'> non reconnue'
	   type*,'** On accepte: ''s'', ''h'', ''d'', ''w'',',
	1	' ''m'', ''a'' '
	   STOP
	ENDIF
!        0         0         0         0         0         0         *72*
!       => periodes des cycles en annees
	if(cycla.ne.0.and.cyclb.ne.0) NS=2
	if(cycla.ne.0.and.cyclb.eq.0) NS=1
	IF (cycla.eq.0.and.cyclb.ne.0) THEN
	   cycla=cyclb
	   cyclb=0
	   NS=1
	ENDIF
	if(cycla.eq.0.and.cyclb.eq.0) NS=0
          
	lps=0
	lpsb=0
	kab=0
          
	IF (NS.eq.0) THEN	
	   write(6,2000)
	   write(16,2000)
 2000	   format(' Pas de composante cyclique')
!          C'est crono.f qui reagit a NS=0
	ENDIF
          
	IF (NS.eq.1) THEN	
	   write(6,2001) cycla,usais
	   write(16,2001) cycla,usais
 2001	   format(' Une composante cyclique:',
	1  f8.2,1x,a1)
          
	   if(usais.eq.'s') cycla= cycla/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cycla= cycla/(24.d0*365.2422d0)
	   if(usais.eq.'d') cycla= cycla/365.2422d0
	   if(usais.eq.'w') cycla= cycla*7.d0/365.2422d0
	   if(usais.eq.'m') cycla= cycla/12.d0
          
!       => periode du premier cyclique en nombre de points
          
	   lps=0.5+(cycla/tabul)
	ENDIF
          
	IF (NS.eq.2) THEN	
	   write(6,2202)  cycla,cyclb,usais
	   write(16,2202) cycla,cyclb,usais
 2202	   format(' Deux composantes cycliques,',2f8.2,1x,a1)
	   if(cab.ne.0) write(6,2002)  cab,usais
	   if(cab.ne.0) write(16,2002) cab,usais
 2002	   format('           Commensurabilite:',f8.2,1x,a1)
          
	   if(usais.eq.'s') cycla= cycla/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cycla= cycla/(24.d0*365.2422d0)
	   if(usais.eq.'d') cycla= cycla/365.2422d0
	   if(usais.eq.'w') cycla= cycla*7.d0/365.2422d0
	   if(usais.eq.'m') cycla= cycla/12.d0
          
!          => periode du premier cyclique en nombre de points
          
	   if(usais.eq.'s') cyclb= cyclb/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cyclb= cyclb/(24.d0*365.2422d0)
	   if(usais.eq.'d') cyclb= cyclb/365.2422d0
	   if(usais.eq.'w') cyclb= cyclb*7.d0/365.2422d0
	   if(usais.eq.'m') cyclb= cyclb/12.d0
          
!           => periode du deuxieme cyclique en nombre de points
          
	   if(usais.eq.'s') cab= cab/(3600.d0*24.d0*365.2422d0)
	   if(usais.eq.'h') cab= cab/(24.d0*365.2422d0)
	   if(usais.eq.'d') cab= cab/365.2422d0
	   if(usais.eq.'w') cab= cab*7.d0/365.2422d0
	   if(usais.eq.'m') cab= cab/12.d0
          
!           => periode du cycle commensurable en nombre de points
          
	   lps=0.5+(cycla/tabul)
	   lpsb=0.5+(cyclb/tabul)
	   kab=0.5+(cab/tabul)
          
	ENDIF
          
c	type*,'=== lps, lpsb',lps,lpsb
          
!       Valeurs frontieres pour les rabotages
!       -------------------------------------
          
	read(1,*) fac,belim,bp,bi ! pour rabotages (2 2 1 ??)
          
	type*,'-- Fin de lecture de crono_vue.dat --'
          
          
!       +---------------------------------------------------------+
!       | Lecture des donnees, avec ou sans sigmas (format libre) |
!       +---------------------------------------------------------+
          
!       Avec/sans sigma (1/0), Titre (a6)
!       ---------------------------------
          
	read(3,*) kpo,sta
          
	do L=31,1,-1
	   ltit=L
	   if(sta(L:L).ne.' ') go to 65
	enddo
 65	continue
          
	write(6,5)  sta(1:ltit), avsan(kpo+1)
	write(16,5) sta(1:ltit), avsan(kpo+1)
 5	format(' -- ',a,': donnees ',a,' sigmas')
          
	I=0
  100	continue
	I=I+1
110	continue
	geri(I)=0.
          
	if(kpo.eq.0) read(3,*,end=200) date(I),seri(I)
	if(kpo.eq.1) read(3,*,end=200) date(I),seri(I),geri(I)
          
!       Transfo d'unites: variable et echelle de temps
          
c	type*,I, date(I),seri(I),geri(I)
          
	IF (I.gt.NF) THEN
	   type*,'** ERREUR: I > NF:',Ntot,' >',NF
	   STOP
	ENDIF
          
	seri(I)=seri(I)*factar  ! => unite SORTIE pour la variable
	geri(I)=geri(I)*factar  ! => unite SORTIE pour la variable
          
	if(ut_ent.eq.'w') date(I)=DMJW(date(I)) ! GPS week =>date MJD
	if(ut_ent.eq.'a') date(I)=DMJD(date(I)) ! ans =>date MJD
          
	tref(I)=1.+(date(I)-date(1))/(tabul*365.2422d0) ! entier/premiere date
c	type*,I,date(I),tref(I),seri(I)
          
!       Dans le cas 'd', on a deja la date en MJD
          
	go to 100
  200	continue
	Ntot=I-1
          
c	type*,ntot,tref(ntot)
          
	IF (tref(ntot).gt.FLOAT(NF)) THEN
	   type*,'** ERREUR: La serie completee sera trop longue:'
	1	 ,tref(ntot),' >',NF
	   STOP
	ENDIF
          
	write(6,201)  ntot,date(1),date(ntot),
	1             tref(ntot),tabul*365.2422
	write(16,201) ntot,date(1),date(ntot),
	1             tref(ntot),tabul*365.2422
 201	format(i7,' mes., MJD:',2f8.1,'. - ',
	1      f7.0,' intervalles de',f10.5,' jours.')
          
!       Controle de la coherence des cycliques demandees
!       avec la duree des donnees (duree > 5 cycles)
          
	IF (NS.ne.0) THEN
	   if(cycla*365.2422.ge.(date(ntot)-date(1))/5.d0)
	1  type*,'** ERREUR: ',
	2	 'Cycle 1 demande',cycla,' ',usais,' trop long'
	   if(cyclb*365.2422.ge.(date(ntot)-date(1))/5.d0)
	1  type*,'** ERREUR: ',
	2	 'Cycle 2 demande',cyclb,' ',usais,' trop long'
          
	   IF (cycla*365.2422.ge.(date(ntot)-date(1))/5.d0.or.
	1      cyclb*365.2422.ge.(date(ntot)-date(1))/5.d0) THEN
	       type*,'** ERREUR: Valeur max possible:',
	1	     ' 1/5 de la duree des obs'
	       STOP
	   ENDIF
	ENDIF
          
          
!                  +------------------------------------+
!                  | Filtrages et analyses statistiques |
!                  +------------------------------------+
          
	CALL CRONO(ntot,kpo,lpsb)
          
!                             +---------+
!	                      | SORTIES |
!                             +---------+
          
!       Sortie des points aberrants elimines avant analyse (NETCENT)
          
	open(26,status='unknown',file='crono_gmt.elim')
          
	do 209 I=1,nlim	
	   truc=dlim(I)                                ! MJD
	   if(ut_sor.eq.'a')truc=DANN(dlim(I))         ! ans
	   write(26,*) truc,elim(I)-centre,I,centre
c	   write(6,*) truc,elim(I)-centre,I,centre
 209	continue
          
	Close (26)
          
!       Sortie des points ajoutes pour combler les trous (CRONO)
          
	open(26,status='unknown',file='crono_gmt.ajou')
          
	do 219 I=1,njou	
	   truc=djou(I)                                ! MJD
	   if(ut_sor.eq.'a')truc=DANN(djou(I))         ! ans
	   write(26,2190) truc,ajou(I),I,centre
 2190	   format(f12.5,f12.4,i5,f12.4)
c	   write(6,*) truc,ajou(I)-centre,I,centre
 219	continue
          
	Close (26)
          
!       Sortie des sries du common ELFIL en unites SORTIE (uni_var)
          
	open(7, status='unknown',file='crono_gmt.tout')
	open(8, status='unknown',file='crono_gmt.tend')
	open(9, status='unknown',file='crono_gmt.saisA')
	open(10,status='unknown',file='crono_gmt.rest')
	if(NS.eq.2)
	1 open(11,status='unknown',file='crono_gmt.saisB')
          
	do 300 k=7,11
	   DO 124 I=1,Ntot
	      if(pt(I).eq.0.) go to 124
	      truc=date(I)                                ! MJD
	      if(ut_sor.eq.'a')truc=DANN(date(I))         ! ans
          
	      pentre=biastend+pentend*(date(I)-date(1))
          
	      if(k.eq.7) write(k,1) truc,(seri(I)-pentre),geri(I),
	1	                    tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.8) write(k,1) truc,(tend(I)-pentre),geri(I),
	1	                    tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.9) write(k,1) truc,sais(I),geri(I),
	1	                    tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.10) write(k,1) truc,rest(I),geri(I),
	1	                     tref(I),resu(k-6),sta(1:ltit)
	      if(k.eq.11.and.NS.eq.2)
	1	          write(k,1) truc,saisB(I),geri(I),
	2	                     tref(I), resu(k-6),sta(1:ltit)
!        0         0         0         0         0         0         |72
    1	      format(f15.8,2f12.4,f7.0,1x,a,1x,a)
 124	   CONTINUE
 300	CONTINUE
          
	Close (7)
	Close (8)
	Close (9)
	Close (10)
	Close (11)
          
          
!       Sortie des spectres du common SPECTRES
!       Unites:  "uni_var" et cycles/"ut_sp"
          
!              On repere la presence d'un spectre de la tendance (kspt=1)
	kspt=1
	if(samp(1,1).eq.0.and.samp(9,1).eq.0)	kspt=0
          
	if(kspt.eq.1) open(12,status='unknown',file='crono_gmt.sp_tend')
	open(13,status='unknown',file='crono_gmt.sp_rest')
          
	   ncot=0
	   ncor=0
	do 400 k=2-kspt,2        !  tend:k=1; rest:k=2
	   DO 350 I=1,NR(k)
	      truc=frq(I,k)                            ! cycle/jour
	      if(ut_sp.eq.'h')truc=frq(I,k)/24.        ! cycle/heure
	      if(ut_sp.eq.'a')truc=frq(I,k)*365.2422   ! cycle/an
	      WRITE(k+11,2) truc,amp(I,k),samp(I,k),
	1	            1./truc,ut_sp,resu(2*k),sta(1:ltit)
 2	      FORMAT(f11.4,f12.4,f8.4,f10.3,' ',a,1x,a,1x,a)
          
	      IF (k.eq.1) THEN
		 ncot=ncot+1
		 sercot(ncot)= amp(I,k) ! pour cotst <= amplitudes de sp_tend
	      ENDIF
	      IF (k.eq.2) THEN
		 ncor=ncor+1
		 sercor(ncor)= amp(I,k) ! pour cotsp <= amplitudes de sp_rest
	      ENDIF
 350	   CONTINUE
 400	CONTINUE
	cotst=BINSUP(sercot,ncot,2)
	cotsp=BINSUP(sercor,ncor,2)
          
	Close (12)
	Close (13)
          
	ncot=0
	do 510 ks=1,NS   ! Pour les deux cycliques
          
!       Sortie des variations du cyclique et de sa premiere harmonique
          
	   open(12,status='unknown',
	1	file='crono_gmt.cy_sais'//undeux(ks)//'1')
	   open(13,status='unknown',
	1	file='crono_gmt.cy_sais'//undeux(ks)//'2')
          
	   do 500 k=1,2      ! la fondamentale et la 1ere harmonique
	      DO 450 I=1,ncy(ks) ! la liste des amplitudes
		   ncot=ncot+1
		   sercot(ncot)=cyc(I,ks,1)
                              ! pour cotamp (d'apres fondam A et B)
	           truc=datecy(I,ks)                           ! MJD
	           if(ut_sor.eq.'a')truc=DANN(datecy(I,ks))    ! ans
	           WRITE(k+11,3) truc,cyc(I,ks,k),scyc(I,ks,k),
	1	                 resu(2*ks+1),k,sta(1:ltit)
 3	         FORMAT(f12.4,f12.3,f9.3,2x,a4,i1,2x,a)
          
 450	      CONTINUE      ! I=1,ncy(ks)  la liste des amplitudes
 500	   CONTINUE         ! k=1,2        la fondamentale et la 1ere harmonique
          
	   Close (12)
	   Close (13)
 510	CONTINUE            ! ks=1,NS      les deux cycliques
	cotamp=BINSUP(sercot,ncot,2)
          
!       Sortie des stat
          
	if(ut_sor.eq.'a') pentend= pentend*365.2422
	if(ut_sor.eq.'a') spentend= spentend*365.2422
c	write(6,41) pentend,spentend,uni_var,ut_sor
c	write(16,41) pentend,spentend,uni_var,ut_sor
c 41	FORMAT(' Pente de la tendance:',f8.3,' +-',f7.3,' ',a6,'/',a1)
          
	type*,'Ecart-type du reste', rms_rest,' ',uni_var,
	1    '. Chi^2 du reste:',chi_rest
          
!       Sortie des variances d'Allan (cm, mois)
!       1: tend+rest; 2:tend;  3: rest;
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2
          
	DO 550 k=1,5+2*(NS-1)
          
	   if(k.eq.1)
	1  open(9,status='unknown',file='crono_gmt.varp_tres')
	   if(k.eq.2)
	1  open(10,status='unknown',file='crono_gmt.varp_tend')
	   if(k.eq.3)
	1  open(11,status='unknown',file='crono_gmt.varp_rest')
          
	   if(k.eq.4)
	1  open(12,status='unknown',file='crono_gmt.varp_ampA1')
	   if(k.eq.5)   !.and.NS.eq.2)
	1  open(13,status='unknown',file='crono_gmt.varp_ampA2')
          
	   if(k.eq.6)   !4)
	1  open(14,status='unknown',file='crono_gmt.varp_ampB1')
	   if(k.eq.7)   !5.and.NS.eq.2)
	1  open(15,status='unknown',file='crono_gmt.varp_ampB2')
          
	   DO 540 L=1,nvz(k)
          
	      if(ut_sp.eq.'d')truc=ALOG10(tz(L,k))          ! jours
	      if(ut_sp.eq.'h')truc=ALOG10(tz(L,k)*24.) ! jours => heures
	      if(ut_sp.eq.'a')truc=ALOG10(tz(L,k)/365.2422) ! jours => ans
          
	      write(8+k,6) truc,ALOG10(vz(L,k)),k
 6	      FORMAT(2f8.4,'  0.',i6)
          
	      if(L.eq.1)      kx=truc*100.
	      if(L.eq.nvz(k)) kx=0.5+(truc*100.+FLOAT(kx))/200.
 540	   continue
          
!             Mediane des log(tau) pour le graphe
          
	      if(k.eq.1) kxv=kx    ! tend, rest
	      if(k.eq.4) kxa=kx    ! cyclA1
	      if(k.eq.6) kxb=kx    ! cyclB1
          
!             Mediane des log(varp) pour le graphe
          
	      IF (k.eq.1) THEN
		 do L=1,nvz(k)
		    vsr(L)=ALOG10(vz(L,k))
		    vpr(L)=1
		 enddo
		 kyv=0.5+DIVERSIG(vsr,vpr,nvz(k),9,vrr) ! mediane tend
	      ENDIF
          
	      IF (k.eq.4) THEN
		 do L=1,nvz(k)
		    vsr(L)=ALOG10(vz(L,k))
		    vsr(L+nvz(k))=ALOG10(vz(L,k+1))
		    vpr(L)=1
		 enddo
		 kav=0
		 if(nvz(k).ne.0) kav=0.5+               ! centre ampA1,ampA2
	1	     0.5*(BINSUP(vsr,nvz(k),1)+BINSUP(vsr,nvz(k),2))
c		 type*,'kav',kav
	      ENDIF
          
	      IF (k.eq.6) THEN
		 do L=1,nvz(k)
		    vsr(L)=ALOG10(vz(L,k))
		    vsr(L+nvz(k))=ALOG10(vz(L,k+1))
		    vpr(L)=1
		 enddo
		 kbv=0
		 if(nvz(k).ne.0) kbv=0.5+               ! centre ampB1,ampB2
	1	     0.5*(BINSUP(vsr,nvz(k),1)+BINSUP(vsr,nvz(k),2))
c		 type*,'kbv',kbv
	      ENDIF
          
 550	continue
          
	Close (9)
	Close (10)
	Close (11)
	Close (12)
	Close (13)
	Close (14)
	Close (15)
          
!                             +--------------------------+
!	                      | Creation de crono_gmt.sh |
!                             +--------------------------+
          
	open(10,status='unknown',file='crono_gmt.s')
	write(10,800)
 800	format('#!/bin/sh'/'echo "Tout et tendance"')
          
!       Trois/quatre fenetres pour tout+tend, saisA/B, rest
!       Ordre de fabrication des cadres:
!       C1, C2, C3; G3, G2, G1; D1, D2, D3. Schema:
          
!                               Sp1----------> Av1
!                               |               |
!                               |       Ts1     |
!                               Sp2      |     Av2
!                               |       Ts2     |
!                               |        |      |
!                               Sp3<----Ts3    Av3
          
	y0=0.
          
!       --------------------------
!       CADRE Ts1: Tout et tendance
!       --------------------------
          
!       Cas des cotes par defaut (0 0 0  0 0):
!       on definit les 5 cotes d'apres les valeurs observees
          
! cotdeb
	if(cotdeb.eq.0.and.ut_sor.eq.'d') cotdeb=date(1)
	if(cotdeb.eq.0.and.ut_sor.eq.'a') cotdeb=DANN(date(1))	
	xd=cotdeb
! cotfin
	if(cotfin.eq.0.and.ut_sor.eq.'d') cotfin=date(ntot)
	if(cotfin.eq.0.and.ut_sor.eq.'a') cotfin=DANN(date(ntot))
	xf=cotfin
! dcot
        if(dcot.eq.0) dcot=0.3*(xf-xd)
	dx=dcot
! cotydeb
	if(cotydeb.eq.0) cotydeb=1.10*ecmax
	yd=-1.5*cotydeb
	yf=cotydeb
! dcoty
        if(dcoty.eq.0) dcoty=0.3*(yf-yd)
	dy=dcoty
          
c	type*,'Tendance dx,dy',dx,dy
          
	write(10,801) xd,xf,yd,yf,dx,dy
 801	format('psxy crono_gmt.tout -X11 -Y14',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'snWe',
             !          -R1660/2100/-49/50       -B50/10snWe
	2      ' -JX11/5 -Sc.02 -W10/0/0/255  -K > crono_gmt.ps')
          
	write(10,802)  ! signal de depart
 802	format('psxy -O crono_gmt.tout',
	1      ' -R -JX  -W2/0/0/255 -K >> crono_gmt.ps')
	write(10,803)  ! valeurs aberrantes supprimees
 803	format('psxy -O crono_gmt.elim -R -JX -Sc.10',
	1      ' -G255/0/255 -K >> crono_gmt.ps')
c	write(10,8030)  ! valeurs ajoutees dans les trous
c 8030	format('psxy -O crono_gmt.ajou -R -JX -Sc.05',
c	1      ' -G200/255/0 -K >> crono_gmt.ps')
	write(10,804)  ! tendance
 804	format('psxy -O crono_gmt.tend -R -JX -Sd0.05',
	1      ' -G0/0/255 -W5/0/255/0  -K >> crono_gmt.ps')
          
!       Titre et commentaires
          
	xe=xf !0.4*(xf+xd)  !/2.
	ye=yf +0.2*(yf-yd)
	write(10,805) xe, ye, sta(1:ltit), tab,monu
 805	format('pstext -O -R -JX -G0/0/255 -N -K',
	1      ' << eof >> crono_gmt.ps'/
	2      2f10.2,' 14 0 0 3 Crono_Vue Analysis of ',a,
	3    ' - Sampling time:',f6.2,' ',a/
	4      'eof')
          
	xe=xd+0.05*(xf-xd)
	ye=yf-0.1*(yf-yd)
	write(10,807) xe, ye, uni_var(1:lvar)
 807	format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2  2f10.2,' 12 0 0 0  Slope-corrected original series (',a,')'/
	3      'eof')
          
	xe=xd+0.05*(xf-xd)
	ye=yd+0.24*(yf-yd)
	write(10,808) xe, ye, uni_var(1:lvar)
 808	format('pstext -O -R -JX -G0/255/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0  Trend (',a,')'/
	3      'eof')
          
          
	xe=xd+0.05*(xf-xd)
	ye=yd+0.1*(yf-yd)
          
	truc=filtre       ! en annees
	if(utend.eq.'s') truc=filtre*3600.d0*24.d0*365.2422d0
	if(utend.eq.'h') truc=filtre*24.d0*365.2422d0
	if(utend.eq.'d') truc=filtre*365.2422d0
	if(utend.eq.'w') truc=filtre*365.2422d0/7.d0
	if(utend.eq.'m') truc=filtre*12.d0
!        0         0         0         0         0         0         |72
	write(10,809)
c	3    xe+0.53*(xf-xd), ye,               taumin,aruc,
	3    xe,             ye-0.08*(yf-yd), biastend,uni_var(1:lvar),
	4    xe+0.53*(xf-xd), ye-0.08*(yf-yd), truc,utend
 809	FORMAT('pstext -O -R -JX -G0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
c	3 2f10.2,' 12 0 0 0 Min Allan var. at',f7.2,1x,a/
	3 2f10.2,' 10 0 0 0 Bias:',f7.1,1x,a/
	4 2f10.2,' 10 0 0 0 Filter length :',f7.2,1x,a/
	5 'eof')
	write(10,8090)
	1             xe,ye,pentend,spentend,uni_var(1:lvar),ut_sor
 8090	FORMAT('pstext -O -R -JX -G255/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2 2f10.2,' 10 0 0 0 Slope:',f8.3,' +-',f7.3,1x,a,'/',a/
	5 'eof')
          
!       ---------------------------
!       CADRE Ts2: Saisonnier(s) A/B
!       ---------------------------
          
	yd=yd/1.5
          
	xe=xd+0.05*(xf-xd)
	ye=yf-0.2*(yf-yd)
          
	do 815 I=1,NS
          
	write(10,810) I
 810	format('################'/'echo "Saisonnier',i2,'"')
          
	IF (I.eq.1) THEN
	   write(10,811) xd,xf,yd,yf,dx,dy
 811	   format('psxy -O crono_gmt.saisA -Y-4',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'snWe',
	2      ' -JX11/4 -W10/0/255/0 -K >> crono_gmt.ps')
          
	   truc=cycla                               ! annees
	   if(ut_sp.eq.'d') truc=truc*365.2422      ! jours
	   if(ut_sp.eq.'h') truc=truc*365.2422*24.  ! heures
          
	   write(10,813) xe,ye, truc,ut_sp,uni_var(1:lvar)
 813	   format('pstext -O -P -R -JX -G0/255/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0 Periodic:',f6.2,1x,a,' (',a,')'/
	3      'eof')
          
	ENDIF
          
	IF (I.eq.2) THEN
	   write(10,812) xd,xf,yd,yf,dx,dy
 812	   format('psxy -O crono_gmt.saisB -Y-4',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'snWe',
	2      ' -JX11/4 -W10/0/255/0 -K >> crono_gmt.ps')
          
	   truc=cyclb                                ! annees
	   if(ut_sp.eq.'d') truc=cyclb*365.2422      ! jours
	   if(ut_sp.eq.'h') truc=cyclb*365.2422*24.  ! heures
	   write(10,813) xe,ye, truc,ut_sp,uni_var(1:lvar)
	ENDIF
          
 815	continue
          
!       ---------------
!       CADRE Ts3: Reste
!       ---------------
          
	write(10,816)
 816	format('################'/'echo "Reste"')
          
	write(10,817) xd,xf,yd,yf,dx,dy
 817	format('psxy -O crono_gmt.rest -Y-4 -JX11/4',
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f7.2,'/',f7.2,'SnWe',
	2      ' -Ey.005/.1/0/0/255 -K >> ',
	3      'crono_gmt.ps'/
	4      'psxy -O crono_gmt.rest -P -R -JX -W10/0/255/0',! -Sc.03
	5      ' -K >> crono_gmt.ps')
          
	if(ut_sor.eq.'a')
	1    write(10,8170) 0.5*(xd+xf),yd-0.3*(yf-yd)
 8170	format('pstext -O -P -R -JX -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 12 0 0 6  Date (years)'/
	3      'eof')
          
	if(ut_sor.eq.'d')
	1    write(10,8171) 0.5*(xd+xf),yd-0.3*(yf-yd)
 8171	format('pstext -O -P -R -JX -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 12 0 0 6  Date (MJD)'/
	3      'eof')
          
	xe=xd+0.05*(xf-xd)
	ye=yf-0.15*(yf-yd)
	write(10,818) xe,ye, uni_var(1:lvar)
 818	format('pstext -O -P -R -JX -G0/255/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 12 0 0 0  Irregular (',a,')'/
	3      'eof')
          
	xe=xf-0.05*(xf-xd)
	if(kpo.eq.1) write(10,8180) xe,ye
 8180	format('pstext -O -P -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 10 0 0 3  Original error bars'/
	3      'eof')
          
	xe=xd+0.05*(xf-xd)
	ye=yd+0.1*(yf-yd)
	write(10,819) xe, ye, rms_rest, uni_var(1:lvar)
 819	format('pstext -O -R -JX -G0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0 Std Dev:',f6.1,1x,a/
	3      'eof')
	if(chi_rest.ne.0) write(10,8190)
	1             xe+0.55*(xf-xd), ye, chi_rest
 8190	format('pstext -O -R -JX -G0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 12 0 0 0 Chi^2:',f8.2/
	3      'eof')
          
!       -----------------------
!       CADRE Sp3: Spectre reste
!       -----------------------
          
	write(10,820)
 820	format('################'/'echo "Spectre Reste"')
          
	xd=-.5/persup(2)                  ! c/jours
	if(ut_sp.eq.'h') xd=xd/24.        ! c/heures
	if(ut_sp.eq.'a') xd=xd*365.2422   ! c/annees
          
	xf=1.1/perinf(2)                  ! c/jours
	if(ut_sp.eq.'h') xf=xf/24.        ! c/heures
	if(ut_sp.eq.'a') xf=xf*365.2422   ! c/annees
          
	yd=-0.2*1.5*cotsp
	yf=1.5*cotsp
          
	dx=0.3*(xf-xd)
	dy=0.3*(yf-yd)
          
	write(10,821) xd,xf,yd,yf,dx,dy
 821	format('psxy -O crono_gmt.sp_rest -X-7 -Y1 -JX5/2.8',
	1      ' -R',2('/',f10.3),2('/',f10.4),' -B',f9.4,'/',f9.4,
	2      'SnWe  -K >> crono_gmt.ps'/
	3      'psxy -O crono_gmt.sp_rest -R -JX',
	2      ' -Sc.01 -Ey.01/.1/0/255/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*
          
	write(10,822)
 822	format('psxy -O crono_gmt.sp_rest -R -JX -W10/0/0/0 -K',
	1      ' >> crono_gmt.ps')
          
	xe=0.5*(xf+xd)
	ye=yf-0.15*(yf-yd)
	write(10,823) xe,ye,ut_sp,
	1             xe,yd+0.13*1.5*cotsp,uni_var(1:lvar)
 823	format('pstext -O -R -JX -G0/0/0 -N -K << eof >> crono_gmt.ps'/
	2      2f11.4,' 10 0 0 6 Periodogram (cycles/',a,')'/
	2      2f11.4,' 10 0 0 6 Irregular (',a,')'/
	3      'eof')
          
c	xe=xd
c	ye=xf
	write(10,824) xd,xf
 824	format('psxy -O -R -JX -W5/0/0/0  -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      f9.2,'  0.'/f9.2,'  0.'/
	3      'eof')
          
	xper1=perinf(2)                         ! jours
	if(ut_sp.eq.'h') xper1=xper1*24.        ! heures
	if(ut_sp.eq.'a') xper1=xper1/365.2422   ! annees
	x1=1./xper1
          
	xper3=persup(2)                         ! jours
	if(ut_sp.eq.'h') xper3=xper3*24.        ! heures
	if(ut_sp.eq.'a') xper3=xper3/365.2422   ! annees
	x3=1./xper3
          
	x2=x3+(x1-x3)/3.
	xper2=1./x2
          
	x4=x3+(x1-x3)*2./3.
	xper4=1./x4
          
	write(10,8540) x1, y0+dy, xper1,ut_sp,
	1              x2, y0+dy, xper2,ut_sp,
	1              x3, y0+dy, xper3,ut_sp,
	1              x4, y0+dy, xper4,ut_sp
 8540	format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	2      2f10.4,' 10  90 0 5 ',f10.4,' ',a/
	3      'eof')
          
!       ------------------------------------------
!       CADRE Sp2: Variations amplitude cyclique(s)
!       ------------------------------------------
          
	do 845 I=NS,1,-1
          
	write(10,830) pcy(I),usais
 830	format('################'/
	1 'echo "Amplitude cyclique',f10.2,' ',a,'"')
          
	   xd=cotdeb
	   xf=cotfin
	   dx=2.*dcot
          
	   yd= 0.
	   yf= 2.*cotamp
	   dy=0.3*(yf-yd)
          
	   IF (I.eq.1) THEN
	      write(10,831) xd,xf,yd,yf,dx,dy
 831	      format('psxy -O crono_gmt.cy_saisA1 -Y4 -JX5/2.8'
	1            ' -R',2('/',f9.3),2('/',f9.3),
	2	     ' -B',f8.4,'/',f8.4,'SnWe',
	3            ' -Sc.01 -K >> crono_gmt.ps'/
          
	1	  'psxy -O crono_gmt.cy_saisA1 -R -JX'
	2	  ' -Ey.01/.1/0/255/255 -G0/255/255 -K',
	3	  ' >> crono_gmt.ps')
          
	      write(10,834)
 834	      format('psxy -O crono_gmt.cy_saisA1 -R -JX',
	1         ' -W10/0/255/255 -K >> crono_gmt.ps'/
          
	1	   'psxy -O crono_gmt.cy_saisA2 -R -JX',
	2         ' -Sc.01 -Ey.01/.1/200/100/0  -W10/200/100/0 -K',
	3         ' >> crono_gmt.ps'/
          
	1	  'psxy -O crono_gmt.cy_saisA2 -R -JX',
	2         ' -W10/200/100/0 -K >> crono_gmt.ps')
          
	      xe=xd+0.1*(xf-xd)
	      ye=yf-0.15*(yf-yd)
	      write(10,835) xe,ye,uni_var(1:lvar)
 835	      format('pstext -O -R -JX -G0/0/0 -N -K << eof'
	1	     ' >> crono_gmt.ps'/
	2      2f15.4,' 10 0 0 0 Amplitudes (',a,')'/
	3      'eof')
          
	      truc=cycla                                ! annees
	      if(ut_sp.eq.'d') truc=cycla*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=cycla*365.2422*24.  ! heures
	      write(10,836) xe,ye-0.20*(yf-yd),truc,ut_sp
 836	      format('pstext -O -R -JX -G0/255/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f15.4,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')
          
	      truc=0.5*cycla                                ! annees
	      if(ut_sp.eq.'d') truc=0.5*cycla*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=0.5*cycla*365.2422*24.  ! heures
	      write(10,8361) xe,ye-0.35*(yf-yd),truc,ut_sp
 8361	      format('pstext -O -R -JX -G200/100/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f9.2,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')
!        0         0         0         0         0         0         |72
	   ENDIF
          
	   IF (I.eq.2) THEN
	      write(10,837) xd,xf,yd,yf,dx,dy
 837	      format('psxy -O crono_gmt.cy_saisB1 -Y4 -JX5/2.8'
	1            ' -R',2('/',f9.3),2('/',f9.3),
	2	     ' -B',f8.4,'/',f8.4,'SnWe',
	3            ' -Sc.01 -K >> crono_gmt.ps'/
          
	1	  'psxy -O crono_gmt.cy_saisB1 -R -JX'
	2	  ' -Ey.01/.1/0/255/255 -G0/255/255 -K',
	3	  ' >> crono_gmt.ps')
          
	      write(10,838)
 838	      format('psxy -O crono_gmt.cy_saisB1 -R -JX',
	1         ' -W10/0/255/255 -K >> crono_gmt.ps'/
          
	1	  'psxy -O crono_gmt.cy_saisB2 -R -JX',
	2         ' -Sc.01 -Ey.01/.1/200/100/0  -W10/200/100/0 -K',
	3         ' >> crono_gmt.ps'/
          
	1	   'psxy -O crono_gmt.cy_saisB2 -R -JX',
	2         ' -W10/200/100/0 -K >> crono_gmt.ps')
          
          
	      xe=xd+0.1*(xf-xd)
	      ye=yf-0.15*(yf-yd)
	      write(10,835) xe,ye,uni_var(1:lvar)
          
	      truc=cyclb                                ! annees
	      if(ut_sp.eq.'d') truc=cyclb*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=cyclb*365.2422*24.  ! heures
	      write(10,8360) xe,ye-0.20*(yf-yd),truc,ut_sp
 8360	      format('pstext -O -R -JX -G0/255/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f9.2,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')
          
	      truc=0.5*cyclb                                ! annees
	      if(ut_sp.eq.'d') truc=0.5*cyclb*365.2422      ! jours
	      if(ut_sp.eq.'h') truc=0.5*cyclb*365.2422*24.  ! heures
	      write(10,8362) xe,ye-0.35*(yf-yd),truc,ut_sp
 8362	      format('pstext -O -R -JX -G200/100/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f9.2,' 10 0 0 0 Period:',f10.4,' ',a/
	3      'eof')
	   ENDIF
          
 845	continue
          
!       --------------------------
!       CADRE Sp1: Spectre tendance
!       --------------------------
          
	write(10,850)
 850	format('################'/'echo "Spectre Tendance"')
          
	xd=0.5/persup(1)                  ! c/jours
	if(ut_sp.eq.'h') xd=xd/24.        ! c/heures
	if(ut_sp.eq.'a') xd=xd*365.2422   ! c/annees
          
	xf=1.1/perinf(1)                  ! c/jours
	if(ut_sp.eq.'h') xf=xf/24.        ! c/heures
	if(ut_sp.eq.'a') xf=xf*365.2422   ! c/annees
          
	yd=-0.2*1.5*cotst
	if(yd.eq.0) yd=-0.2*1.5*cotsp  ! on prend la valeur du spectre de l'irregulier
	yf=1.5*cotst
	if(yf.eq.0) yf=1.5*cotsp       ! on prend la valeur du spectre de l'irregulier
          
	dx=0.3*(xf-xd)
	dy=0.3*(yf-yd)
          
	IF (kspt.eq.1) THEN
          
	write(10,851) xd,xf,yd,yf,dx,dy
 851	format('psxy -O crono_gmt.sp_tend -Y4 -JX5/2.8',
	1      ' -R',2('/',f10.3),2('/',f10.3),' -B',f9.4,'/',f9.4,'SnWe',
	2      ' -Sc.01 -Ey.01/.1/0/255/0 -K >> crono_gmt.ps')
          
	   write(10,852)
 852	   format('psxy -O crono_gmt.sp_tend -R -JX -W10/0/0/0 -K',
	1      ' >> crono_gmt.ps')
          
	   xe=0.5*(xf+xd)
	   ye=yf-0.12*(yf-yd)
	   write(10,8233) xe, ye, ut_sp,
	1              xe, yd+0.15*1.5*cotst, uni_var(1:lvar)
 8233	   format('pstext -O -R -JX -G0/0/0 -N -K << eof >> crono_gmt.ps'/
	2      2f11.4,' 10 0 0 6 Periodogram (cycles/',a,')'/
	2      2f11.4,' 10 0 0 6 Trend (',a,')'/
	3      'eof')
          
c	   xe=xd
c	   ye=xf
	   write(10,853) xd,yf
 853	   format('psxy -O -R -JX -W5/0/0/0 -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      f12.5,'  0.'/f12.5,'  0.'/
	3      'eof')
          
	   xper1=perinf(1)                       ! jours
	   if(ut_sp.eq.'h') xper1=xper1*24.      ! heures
	   if(ut_sp.eq.'a') xper1=xper1/365.2422 ! annees
	   x1=1./xper1
          
	   xper3=persup(1)                       ! jours
	   if(ut_sp.eq.'h') xper3=xper3*24.      ! heures
	   if(ut_sp.eq.'a') xper3=xper3/365.2422 ! annees
	   x3=1./xper3
          
	   x2=x3+(x1-x3)/3.
	   xper2=1./x2
          
	   x4=x3+(x1-x3)*2./3.
	   xper4=1./x4
          
	   write(10,8540) x1, y0, xper1,ut_sp,
	1              x2, y0, xper2,ut_sp,
	1              x3, y0, xper3,ut_sp,
	1              x4, y0, xper4,ut_sp
          
	   xe=0.5*(xf+xd)
	   ye=yf+0.3*(yf-yd)
	   write(10,854) xe,ye+0.25*(yf-yd), xe,ye
 854	   format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f12.4,' 14 0 0 6 Spectral content'/
	2      2f12.4,' 12 0 0 6 Least square analyses'/
	3      'eof')
          
	ELSE
          
	   write(10,8510)
 8510	   format('psxy -O -Y4 crono_gmt.sp_rest -JX5/2.8',
	1      ' -R/0/1/-1001/-1000 -B/7/7snwe -K >> crono_gmt.ps'/
	2      'pstext -O -R -JX -G0/255/0 -N -K << eof >> crono_gmt.ps'/
	3      '.5 -1000.4 10 0 0 6 Low frequency spectrum'/
	4      '.5 -1000.6 10 0 0 6 not available'/
	5      'eof'/
	6      'pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      '.5 -999.45 14 0 0 6 Spectral content'/
	2      '.5 -999.70 12 0 0 6 Least square analyses'/
	3      'eof')
          
	ENDIF
          
          
!       ----------------------------
!       CADRE Av1: Stabilite tendance
!       ----------------------------
          
	write(10,860)
 860	format('################'/'echo "Stabilite Tendance"')
          
	xd=kxv-2.5    ! centre sur tau median
	xf=kxv+2.5
          
	yd=kyv-2.5    ! centre sur variance mediane
	yf=kyv+2.5
          
	dx= 1.
	dy= 1.
          
	write(10,861) xd,xf,yd,yf,dx,dy
 861	format('psxy -O crono_gmt.varp_tend -X20.5 -JX2.5/2.5'
	1      ' -R',2('/',f10.2),2('/',f10.2),' -B',f9.4,'/',f9.4,'SnWe',
	1      ' -Sd0.2 -W10/0/255/0 -K >> crono_gmt.ps')
          
	write(10,862)
 862	format('psxy -O crono_gmt.varp_tres -R -JX -Sd0.2',
	1      ' -W10/0/0/255 -K >> crono_gmt.ps')
          
	write(10,863) 0.5*(xd+xf), yf+4.5,
	1             0.5*(xd+xf), yf+3.5,
	1             0.5*(xd+xf)-4.5, yf+3.5,
	1             0.5*(xd+xf)-2.2, yf+1.0,
	2             0.5*(xd+xf)+1.3, yf+1.0
!        0         0         0         0         0         0         *72*
 863	format('pstext -O -R -JX -G0/0/255 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 14 0 0 6 Allan variance'/
	2      2f10.2,' 14 0 0 6 Analysis'/
	2      2f10.2,' 8 -45 0 0  White noise'/
	2      2f10.2,' 8   0 0 0  Flicker noise'/
	2      2f10.2,' 8  45 0 0  Random walk'/
	3      'eof')
          
	write(10,865) xd-2.0, yd,
	1             xd-.5, yd-2.1, ut_sp
 865	format('pstext -O -R -JX -G0/0/0 -N -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 8  90 0 0  log (Allan variance)'/
	2      2f10.2,' 8   0 0 0  log (Sampling time [',a1,'])'/
	3      'eof')
          
	write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)
 8650	format('pstext -O -R -JX -G0/0/0 -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 6  0 0 5  100 ',a/
	2      2f10.2,' 6  0 0 5  10 ',a/
	2      2f10.2,' 6  0 0 5  1 ' ,a/
	2      2f10.2,' 6  0 0 5  .1 ',a/
	2      2f10.2,' 6  0 0 5  .01 ',a/
	3      'eof')
          
        x1=kxv
        xper1=10**x1
        x2=kxv-1
        xper2=10**x2
        x3=kxv+1
        xper3=10**x3
        x4=kxv+2
        xper4=10**x4
          
	write(10,8651) x1, yd+.05, xper1,ut_sp,
	1              x2, yd+.05, xper2,ut_sp,
	1              x3, yd+.05, xper3,ut_sp,
	1              x4, yd+.05, xper4,ut_sp
 8651	format('pstext -O -R -JX -G0/0/0 -K << eof',
	1      ' >> crono_gmt.ps'/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	2      2f10.2,' 6 90 0 5 ',f10.4,' ',a/
	3      'eof')
          
!       -------------------------------
!       CADRE Av2: Stabilite Cyclique(s)
!       -------------------------------
          
	write(10,870)
 870	format('################'/'echo "Stabilite Cyclique(s)"')
          
	DO 879 I=1,NS   ! NS: nb de composantes cycliques
          
	   IF (I.eq.1) THEN
	      xd=kxa-2.5
	      xf=kxa+2.5
	      yd=kav-2.5	! centre sur variance mediane
	      yf=kav+2.5
	   ELSE
	      xd=kxb-2.5
	      xf=kxb+2.5
	      yd=kbv-2.5	! centre sur variance mediane
	      yf=kbv+2.5
	   ENDIF
          
	   IF (I.eq.1) THEN
	      write(10,871) xd,xf,yd,yf,dx,dy
 871	      format('psxy -O crono_gmt.varp_ampA2 -Y-4 -JX2.5/2.5'
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f8.3,'/',f8.3,'SnWe',
	1      ' -Sd0.2 -W10/200/100/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*
          
	      write(10,872)
 872	      format('psxy -O crono_gmt.varp_ampA1 -R -JX -Sd0.2',
	1      ' -W10/0/255/255 -K >> crono_gmt.ps')
          
	      write(10,865)  xd-2.0, yd, xd-.5, yd-2.1,ut_sp
	      write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)
          
              x1=kxv
              xper1=10**x1
              x2=kxv-1
              xper2=10**x2
              x3=kxv+1
              xper3=10**x3
              x4=kxv+2
              xper4=10**x4
          
	      write(10,8651) x1, yd+.05, xper1,ut_sp,
	1              x2, yd+.05, xper2,ut_sp,
	1              x3, yd+.05, xper3,ut_sp,
	1              x4, yd+.05, xper4,ut_sp
          
	   ENDIF
          
	   IF (I.eq.2) THEN
	      write(10,873) xd,xf,yd,yf,dx,dy
 873	      format('psxy -O crono_gmt.varp_ampB2 -Y-4 -JX2.5/2.5'
	1      ' -R',2('/',f8.2),2('/',f8.2),' -B',f8.3,'/',f8.3,'SnWe',
	1      ' -Sd0.2 -W10/200/100/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*
          
	      write(10,874)
 874	      format('psxy -O crono_gmt.varp_ampB1 -R -JX -Sd0.2',
	1      ' -W10/0/255/255 -K >> crono_gmt.ps')
          
	      write(10,865)  xd-2.0, yd, xd-.5, yd-2.1,ut_sp
	      write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)
	   ENDIF
          
 879	continue
          
          
!       -------------------------
!       CADRE Av3: Stabilite reste
!       -------------------------
          
	xd=kxv-2.5
	xf=kxv+2.5
	yd=kyv-2.5    ! centre sur variance mediane
	yf=kyv+2.5
          
	write(10,880)
 880	format('################'/'echo "Stabilite Reste"')
          
	write(10,881) xd,xf,yd,yf,dx,dy
 881	format('psxy -O crono_gmt.varp_rest -Y-4 -JX2.5/2.5'
	1      ' -R',2('/',f9.3),2('/',f9.3),' -B',f8.3,'/',f8.3,'SnWe',
	1      ' -Sd0.2 -W10/0/255/0 -K >> crono_gmt.ps')
!        0         0         0         0         0         0         *72*
          
	write(10,882)
 882	format('psxy -O crono_gmt.varp_tres -R -JX -Sd0.2',
	1      ' -W10/0/0/255 -K >> crono_gmt.ps')
          
	write(10,865) xd-2.0, yd, xd-.5, yd-2.1,ut_sp
	write(10,8650)xd+0.1, y0+4., uni_var(1:lvar),
	1             xd+0.1, y0+2., uni_var(1:lvar),
	2             xd+0.1, y0,    uni_var(1:lvar),
	2             xd+0.1, y0-2., uni_var(1:lvar),
	2             xd+0.1, y0-4., uni_var(1:lvar)
          
        x1=kxv
        xper1=10**x1
        x2=kxv-1
        xper2=10**x2
        x3=kxv+1
        xper3=10**x3
        x4=kxv+2
        xper4=10**x4
          
	write(10,8651) x1, yd+.05, xper1,ut_sp,
	1              x2, yd+.05, xper2,ut_sp,
	1              x3, yd+.05, xper3,ut_sp,
	1              x4, yd+.05, xper4,ut_sp
          
!       -------------------------
!       On termine le fichier gmt
!       -------------------------
          
	write(10,895)
 895	format('pstext -O -R -JX -G0/0/0 -N',
	1      ' << eof >> crono_gmt.ps'/'eof'/
	2      'ps2epsi crono_gmt.ps crono_gmt.eps'/
	3      'echo "gs crono_gmt.ps"'/'## Fin ##')
          
	Close (10)
          
!       On remplace les blancs parasites par des 0
          
	open(10,status='old',readonly,file='crono_gmt.s')
	open(11,status='unknown',file='crono_gmt.sh')
          
 900	read(10,901,end=1000) chaine
 901	format(a)
	lch=300
          
	do 903 I=lch,1,-1
	   if(chaine(I:I).ne.' ') go to 904
 903	continue
 904	lch=I
c	type*,lch
c	if(lch.gt.140)
c	1    type*,'crono_gmt.s:',lch,' - ',chaine(1:40)
          
	DO L=1,10
          
	do 910 I=2,lch
	   IF (chaine(I:I).eq.'/'.or.chaine(I-1:I).eq.'-B') THEN
	      k=0
 905	      k=k+1
	      IF (chaine(I+k:I+k).eq.' ') THEN
c		 chaine(I+k:I+k)='0'
		 do 908 J=I+k,lch
		    chaine(J:J)=chaine(J+1:J+1)
 908		 continue
		 go to 905
	      ENDIF
	   ENDIF
 910	continue
          
	ENDDO
          
 	write(11,911) (chaine(I:I),I=1,lch)
 911	format(132a1)
	go to 900
          
 1000	continue
          
	type*,'-- Suite: chmod +x crono_gmt.sh; crono_gmt.sh;',
	1     'gs crono_gmt.ps  --'
          
	Close (10)
	Close (11)
          
	Close (16)
          
	stop
        end
	Subroutine CRONO(npts,kpo,lpsb)

!       Filtrage des series chronologiques
!       Appel de ELFIL et analyses diverses de ses sorties

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,Nsp,Ncc,Nst,NIC
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nsp=1000)  ! Nb de pts du spectre (spfil.f)
	Parameter (Ncc=1000)  ! Nb de cycles sur la duree totale 
	Parameter (Nst=1000)   ! Nb de variances d'Allan (common STAT)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS

      	Real*8    datav,t_date(NF)
      	Real*4    teru,t_SERI(NF),t_GERI(NF),t_TEND(NF),t_SAIS(NF),
	1         poids(NF),biais,pente,pctd,trud
	Integer*4 J,kpt,ks,kt,L,npts

!       Declarations pour recevoir les donnees a analyser et retourner les ajouts

	Character*6  nom_var            ! nom de l'unite en sortie
      	Real*8       date,djou
      	Real*4       tref,geri,ajou
	Integer*4    itrou,kpo
	COMMON/DONNEES/date(NF),nom_var,tref(NF),geri(NF)
	COMMON/AJOUS/djou(NF),ajou(NF),itrou

!                Interface avec ELFIL

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

!                Supplement pour ELFIL2

	Integer*4 lpsb

!                Interface avec SPFIL 

      	Real*4       resp(NF),TJ2000,frq,amp,samp,pt,perinf,persup
	Integer*4    NR,num
	COMMON/SPECTRES/frq(Nsp,2),amp(Nsp,2),samp(Nsp,2),NR(2),pt(NF),
	1               perinf(2),persup(2)

!                Pour MCGAUSS

	Real*8    ARG,A,YZ
	Real*4    sigma,R,SIG,XS,cc,pg
	Integer*4 neq,ninc
	Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
	1           SIG(NIC),XS(NIC),cc(NIC,NIC)

!                Pour transmettre en retour les variations du cyclique

c	Real*4    datecy,cyc,scyc,deb,fin,DIVERSIG

	Real*8    datecy
	Real*4    cyc,scyc,deb,fin,DIVERSIG
	Integer*4 I,ncy,NS
	Common/CYCL/datecy(Ncc,2),cyc(Ncc,2,2),scyc(Ncc,2,2),ncy(2),NS

!                Pour recevoir les stat de NETCENT

      	Real*8      dlim
      	Real*4      elim,centre,ecmax,fac
	Integer*4   nlim
	COMMON/ELIMS/dlim(NF),elim(NF),nlim,centre,ecmax,fac

!                Pour transmettre en retour les stat de VARBRUIT
!        0         0         0         0         0         0         *72*

	Real*4    biastend,pentend,spentend,pent,sent,rms_rest,pv,
	1         chi_rest,tz,vz,rr(NF),pr(NF),prest(NF),pcy
	Integer*4 nvz,kab
	Common/STAT/pcy(3),kab,biastend,pentend,spentend,pent(7),sent(7),
     .              tz(Nst,7),vz(Nst,7),nvz(7),rms_rest,chi_rest,pv(NF)
!       1: tend+rest; 2:tend;  3: rest;    
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2

c	type*,' CRONO:', npts,' mesures recues,',date(1),date(npts)

c	write(16,1)
 1	format(78('-')/'CRONO')
	
	ntot=npts

	do 1001 I=1,ntot
	poids(I)=1.
	if(geri(I).ne.0) poids(I)=1./geri(I)**2.
 1001	continue

	datdep=date(1)        ! les dates sont donnes en MJD

!       Intervalle tabulaire, limp (tend) et lps (saisA, saisB) en jours

	teru= (date(ntot)-date(1))/(tref(ntot)-tref(1))
	pctd=limp*teru
	pcy(1)=lps*teru    ! saisA
	pcy(2)=lpsb*teru   ! SaisB
	pcy(3)=kab*teru    ! Commensurabilite

	IF (NS.eq.0) THEN  ! Ondefinit une periode pour un pseudo-saisonnier
	   pcy(1)=0.1*(date(ntot)-date(1))
	   lps=pcy(1)/teru
	ENDIF

c	type*,'Interv. tab., sais, filtre tend:',teru,pcy,pctd,' d'

!       ------------------------------------------------------
	type*,'Elimination des valeurs aberrantes eventuelles'
!       ------------------------------------------------------

	CALL NETCENT(poids,ntot)

	type*,'Centrage:',centre,' ',nom_var,
	1     '  |ecart max|:',ecmax,' ',nom_var

!       On corrige la serie centree de sa pente globale
!       -----------------------------------------------

	neq=0
	do 253 L=1,ntot
	   neq=neq+1
           A(neq,1)=1.d0
           A(neq,2)=date(L)-date(ntot/2)
           YZ(neq)=seri(L)	
 253	continue
	ninc=2

	CALL MCGAUSS(Neq,Ninc)

	biais=XS(1)  
	pente=XS(2)

	do 254 L=1,ntot
	   seri(L)=seri(L)-biais-pente*(date(L)-date(ntot/2))
 254	continue

	type*,'Biais-pente enleve:',
	1      biais,' ',nom_var,pente,' ',nom_var,'/d'

	type*,'Premier passage d''Elfil (serie a trous)'
!       ------------------------------------------------

	interu=1                  ! intervalle naturel

	CALL ELFIL     ! Filtrage preliminaire pour combler les trous

!       --------------------------------------------------------
!       On comble les trous de la srie  partir de Tend et Sais
!       --------------------------------------------------------

	type*,'Comblement des trous'
c	write(6,15) 
	write(16,15) 
 15	format(78('-')/'CRONO')
      
	itrou=0
	J=0
	kt=0
	datav=date(1)-teru
 100	J=J+1
c	if(itrou.gt.45) STOP
	if(J.gt.ntot) go to 150
 110	continue

c	if(J.gt.1) 
c	1    type*,'Intervalle:',J,date(J),datav,date(J)-datav-teru

	IF (DABS(date(J)-datav-teru).le.0.49d0 * teru) THEN

	   kt=kt+1
	   pt(kt)=1.
	   pv(kt)=1.
	   t_tend(kt)=tend(J)
	   t_sais(kt)=sais(J)
	   t_seri(kt)=seri(J)
	   t_geri(kt)=geri(J)
	   t_date(kt)=date(J)
	   datav=t_date(kt)
	   go to 100
	ELSE
	   itrou=itrou+1
 	   kt=kt+1
	   pt(kt)=0.
	   pv(kt)=0.
c	   t_tend(kt)=tend(J-1)
	   t_tend(kt)=tend(J-1)+
	1	      (tend(J)-tend(J-1))/(date(J)-date(J-1))

	   IF (J.lt.lps) THEN
	      t_sais(kt)=0
	      t_seri(kt)=tend(J-1)+
	1	         (tend(J)-tend(J-1))/(date(J)-date(J-1))
	   ELSE
	      t_sais(kt)=sais(J-1-lps)
	      t_seri(kt)=sais(J-1-lps)+ tend(J-1)+
	1	         (tend(J)-tend(J-1))/(date(J)-date(J-1))
	   ENDIF
!        0         0         0         0         0         0         |72

c	   if(J.lt.lps) t_sais(kt)=0. 
c	   if(J.ge.lps) t_sais(kt)=sais(J-1-lps)
c	   if(J.lt.lps) t_seri(kt)=tend(J-1)
c	   if(J.ge.lps) t_seri(kt)=tend(J-1)+sais(J-1-lps)

	   t_geri(kt)=0.
	   t_date(kt)=t_date(kt-1)+teru
	   datav=t_date(kt)
c	   type*,'Trou',itrou,':',J-1,date(J-1),' -',kt,t_date(kt)

	   djou(itrou)=t_date(kt)
	   ajou(itrou)=t_seri(kt)

c	   write(6,17)t_date(kt),t_seri(kt),kt,itrou 
c	   write(16,17)t_date(kt),t_seri(kt),kt,itrou 
 17	   format('Trou comble. Date:',f12.5,' Valeur:',f10.5,
	1	' ligne No',2i5)
	   go to 110
	ENDIF

 150	continue

	if(itrou.ne.0) write(6,16) itrou,ntot,kt
	write(16,16) itrou,ntot,kt
 16	format(i6,' trous combles dans la serie',
	1    i6,' =>',i6,' mesures')

	ntot=kt
	npts=ntot

	do 200 J=1,ntot
	   seri(J)=t_seri(J)	
	   geri(J)=t_geri(J)	
	   date(J)=t_date(J)	
c         write(6,46) J, date(J),seri(J),geri(J)
 46      format('##',i5,4f10.3)
 200	continue

!       ---------------------
!       Appel de Elfil/Elfil2
!       ---------------------

	IF (NS.eq.0) THEN
	   type*,'Elfil:',
	1	' pseudo-composante cyclique, periode',pcy(1),' d'
	   CALL ELFIL		       ! Filtrage final, sans cyclique

	   do  220 L=1,ntot
	      rest(L)=rest(L)+sais(L)
 220	   continue
	ENDIF


	IF (NS.eq.1) THEN
	   type*,'Elfil:',NS,' composante de periode',pcy(1),' d'
	   CALL ELFIL		       ! Filtrage final, une cyclique
	ENDIF


	IF (NS.eq.2) THEN
	   type*,'Elfil:',NS,' deux composantes de periodes',
	1	pcy(1),' et',pcy(2),' d'
	   CALL ELFIL2(lpsb,saisB)	! Filtrage final, deux cycliques      
	ENDIF


!       On retablit la pente enlevee avant les passages par Elfil/Elfil2
!       ----------------------------------------------------------------

	do 244 L=1,ntot
	   seri(L)=seri(L)+biais+pente*(date(L)-date(ntot/2))
	   tend(L)=tend(L)+biais+pente*(date(L)-date(ntot/2))
 244	continue

!       Pente finale de tendance + irregulier
!       -------------------------------------

	neq=0
	do 250 L=1,ntot
	   if(pt(L).eq.0.) go to 250   ! Pts ajoutes
	   neq=neq+1
! Poids
	   pg=1.
	   if(kpo.eq.1) pg=1./geri(L)

           A(neq,1)=1.d0*pg
           A(neq,2)=(date(L)-date(1))*pg
           YZ(neq)= (tend(L)+rest(L))*pg	
 250	continue
	ninc=2

	CALL MCGAUSS(Neq,Ninc)

	biastend=XS(1)
	pentend=XS(2)  
	spentend=SIG(2)

!       Ecart-type du reste
!       -------------------

	neq=0
	do 260 L=1,ntot
	   if(pt(L).eq.0.) go to 260
	   neq=neq+1
           pr(neq)=1.d0
           prest(neq)=rest(L)
 260	continue

	rms_rest=DIVERSIG(prest,pr,Neq,5,rr)     ! moyenne quadratique

!       ------------------------------------------
	type*,'Spectre de la tendance et du reste'
!       ------------------------------------------

	TJ2000=51544.03
	do 350 num=1,2

	   do 300 L=1,ntot
	      resp(L)=0	
 300	   continue

	   IF (num.eq.1) THEN        ! => Spectre de la tendance
	      perinf(num)=pctd                      ! largeur filtre tendance
	      persup(num)=0.33*(date(ntot)-date(1)) ! 1/3 longueur de la serie
	      NR(num)=100
	      if(Ntot.lt.250) NR(num)=FLOAT(NR(num))/2.5
	      IF(persup(num).gt.perinf(num)) THEN
!                On ne transfere tend => serie a analyser que si
!                persup > perinf, i.e. si la serie est assez longue 
!                comparee a la longueur du filtre de la tendance.
!                Sinon, au n'aura pas de spectre de la tendance.
	         do 305 L=1,ntot
	            resp(L)=tend(L)	
 305	         continue
	      ENDIF
	   ENDIF

	   IF (num.eq.2) THEN         ! => Spectre du reste
	      perinf(num)=1.9*teru
	      persup(num)=2*pctd
	      NR(num)=100
	      if(Ntot.lt.250) NR(num)=FLOAT(NR(num))/2.5
	      do 310 L=1,ntot
	         resp(L)=rest(L)	
 310	      continue
	   ENDIF

	   CALL SPFIL(Ntot,NR(num),TJ2000,date,resp,num)

 350	continue

	type*,'Amplitude cyclique(s)'

!       ------------------------------------------------------------------
!       Variation de l'amplitude du/des cyclique(s) et premire harmonique
!       ------------------------------------------------------------------

	IF (kab.eq.0) THEN
!                               1) cas non commensurable

	   DO 450 ks=1,NS ! saisA (NS=1) et eventuellement saisB (NS=2) 
	      if(ks.eq.1) kpt=lps
	      if(ks.eq.2) kpt=lpsb

c	      type*,ks,lps,lpsb,kpt,' <- KPT'

	      ncy(ks)=0
	      do 400 L=1,ntot,kpt
	         neq=0
c	         type*,'Crono 400',L,':',(L-1)+1,(L-1)+kpt
	         do 360 I=1,kpt
	            J=(L-1)+I
	            if(pt(J).eq.0.) go to 360
	            neq=neq+1
	            if(neq.eq.1) deb=date(J)
! Poids
		    pg=1.
		    if(kpo.eq.1) pg=1./geri(J)

                    ARG=(date(J)-date(1))*2.d0*3.1415927d0/pcy(ks)
		    ARG=DMOD(ARG,2.d0*3.1415927d0)
                    A(neq,1)=1.d0*pg
                    A(neq,2)=dSIN(ARG)*pg
                    A(neq,3)=dCOS(ARG)*pg
                    A(neq,4)=dSIN(2.d0*ARG)*pg
                    A(neq,5)=dCOS(2.d0*ARG)*pg
                    YZ(neq)= (seri(J)-tend(J))*pg	
	            fin=date(J)
 360	         continue
	         ninc=5

	         IF(neq.lt.10 .or. neq.lt.2*kpt/3) go to 400

	         CALL MCGAUSS(Neq,Ninc)

	         ncy(ks)=ncy(ks)+1  ! Nb de determ. d'ampl. pour cycle ks
	         datecy(ncy(ks),ks)=0.5*(fin+deb)
! Fondamentale
	         cyc(ncy(ks),ks,1)= SQRT((XS(2)**2)+(XS(3)**2))
	         scyc(ncy(ks),ks,1)=SQRT((SIG(2)**2)+(SIG(3)**2))
! Harmonique 1
	         cyc(ncy(ks),ks,2)= SQRT((XS(4)**2)+(XS(5)**2))
	         scyc(ncy(ks),ks,2)=SQRT((SIG(4)**2)+(SIG(5)**2))

 400	      continue ! L=1,ntot,kpt

 450	   CONTINUE    ! ks=1,NS: saisA (NS=1) et saisB (NS=2) 
	   
	ELSE
!                               2) cas commensurable (kab non nul, et NS=2)
	   kpt=kab
	   ks=2
	   ncy(ks)=0

	   do 500 L=1,ntot,kpt
	      neq=0

c	      Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
c	1                 SIG(NIC),XS(NIC),cc(NIC,NIC)
	      do 455 I=1,NF
		 YZ(I)=0.d0
		 do 454 J=1,NIC 
		    A(I,J)=0.d0
 454		 continue
 455	      continue

	      do 460 I=1,kpt
	         J=(L-1)+I
	         if(pt(J).eq.0.) go to 460
	         neq=neq+1
	         if(neq.eq.1) deb=date(J)
! Poids
		 pg=1.
		 if(kpo.eq.1) pg=1./geri(J)
! Constante
                 A(neq,1)=1.d0*pg
! SaisA1
                 ARG=(date(J)-date(L))*2.d0*3.1415927d0/pcy(1) 
		 ARG=DMOD(ARG,2.d0*3.1415927d0)
                 A(neq,2)=dSIN(ARG)*pg
                 A(neq,3)=dCOS(ARG)*pg
! SaisA2
                 A(neq,4)=dSIN(2.*ARG)*pg
                 A(neq,5)=dCOS(2.*ARG)*pg
! SaisB1
                 ARG=(date(J)-date(L))*2.d0*3.1415927d0/pcy(2) 
		 ARG=DMOD(ARG,2.d0*3.1415927d0)
                 A(neq,6)=dSIN(ARG)*pg
                 A(neq,7)=dCOS(ARG)*pg
! SaisB2
                 A(neq,8)=dSIN(2.*ARG)*pg
                 A(neq,9)=dCOS(2.*ARG)*pg
! Observation
                 YZ(neq)=(seri(J)-tend(J))*pg  	
		 if(neq.eq.120) trud=seri(J)-tend(J)

	         fin=date(J)
 460	      continue
	      ninc=9

	      IF(neq.lt.15 .or. neq.lt.2*kpt/3) go to 500

	      CALL MCGAUSS(Neq,Ninc)

	      ncy(ks)=ncy(ks)+1
	      ncy(1)=ncy(ks)

	      datecy(ncy(ks),ks)=0.5*(fin+deb)
	      datecy(ncy(1),1)=0.5*(fin+deb)

c	      if(ncy(ks).ge.14) write(6,666),ncy(ks),neq,ninc,
c	1	   2000.0d0+(0.5*(fin+deb)-51544.03d0)/365.2422d0,
c	1	   pcy(1),SQRT((XS(2)**2.)+(XS(3)**2.)),
c	1	          SQRT((XS(4)**2.)+(XS(5)**2.)),
c	1	   pcy(2),SQRT((XS(6)**2.)+(XS(7)**2.)),
c	1	          SQRT((XS(8)**2.)+(XS(9)**2.)),trud
 666	      format(3I4,7f7.1,e10.3)

	      ks=1              ! SaisA1, SaisA2

	      cyc(ncy(ks),ks,1)= SQRT((XS(2)**2.)+(XS(3)**2.))
	      scyc(ncy(ks),ks,1)=SQRT((SIG(2)**2.)+(SIG(3)**2.))

	      cyc(ncy(ks),ks,2)= SQRT((XS(4)**2.)+(XS(5)**2.))
	      scyc(ncy(ks),ks,2)=SQRT((SIG(4)**2.)+(SIG(5)**2.))

	      ks=2              ! SaisB1, SaisB2

	      cyc(ncy(ks),ks,1)= SQRT((XS(6)**2.)+(XS(7)**2.))
	      scyc(ncy(ks),ks,1)=SQRT((SIG(6)**2.)+(SIG(7)**2.))

	      cyc(ncy(ks),ks,2)= SQRT((XS(8)**2.)+(XS(9)**2.))
	      scyc(ncy(ks),ks,2)=SQRT((SIG(8)**2.)+(SIG(9)**2.))

 500	   continue
	ENDIF


!       ---------------------------------------------------------------------
!       Type de bruit de la tendance et du reste et de l'amplitude du 1 cycle
!       (variance d'Allan)
!       ---------------------------------------------------------------------

c	type*,'Variances d''Allan'

	CALL VARBRUIT(ntot,kpo,teru)   !,lpsb)
	
	return
	end
      SUBROUTINE ALLAN(NDIM,T,TAU,VARP,IECR)
C
C     PROGRAMME ALLAN, CALCULE LA VARIANCE D'ALLAN
C
	Integer*4   NF,Nst
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nst=1000)  ! Nb de variances d'Allan 
      Real*8 T(NDIM),B(NF)
      Real*4 DL(Nst),FL(Nst),VARP(Nst)
C
C     NDIM EST LA DIMENSION DU TABLEAU T****** DIMENSION MAXIMUM=NF
C     T EST LE TABLEAU QUI CONTIENT LES NOMBRES A ANALYSER
C
      IF(IECR.NE.0) WRITE(6,1) 
    1 FORMAT(//30X,'VARIANCES D''ALLAN',//,18X,'TAU',7x,'VAR(TAU)',4X,
     .'VAR(TAU)**0.5',3X,'LOG(TAU)',3X,'LOG(VAR)'//)
      K=1
      NP=NDIM-1
C
C     TAU EST L'INTERVALLE DE TEMPS SEPARANT 2 NOMBRES SUCCESSIFS
C
      NK=0
      NDEM=NDIM/2
      KL=0
  104 IF(K.GT.NDEM) GO TO 110
      MM=(NP/K)-1
      IF(MM.LE.0) GO TO 110
      NK=NK+1
      DO 105 I=1,NDIM
  105 B(I)=0
      IM=1
      J=1
  101 IN=IM+K-1
      IF(IN.GT.NP) GO TO 102
      DO 100 I=IM,IN
  100 B(J)=B(J)+T(I)
      B(J)=B(J)/FLOAT(K)
      IM=IN+1
      J=J+1
      GO TO 101
  102 JMAX=J-1
      JMA=J-2
      VAR=0
      DO 103 I=1,JMA
  103 VAR=VAR+(B(I+1)-B(I))**2
      VAR=VAR/FLOAT(2*MM)
      RVAR=SQRT(VAR)
C
C     RVAR A POUR UNITE : L'UNITE DE T/L'UNITE DE TAU
C
      R=TAU*K
      VARP(NK)=RVAR
      RL=ALOG10(R)
      VL=ALOG10(VAR)
      IF(IECR.NE.0) WRITE(6,2) R,VAR,RVAR,RL,VL           
    2 FORMAT(10X,F12.2,2E15.4,2(3X,F8.4))
      KL=KL+1
      DL(KL)=RL
      FL(KL)=VL
      K=2*K                                                     
C     1+K=K
      GO TO 104
  110 CONTINUE
      VARP(NK+1)=0.
      VARP(Nst)=PP
      RETURN
      END


	FUNCTION BINSUP(A,N,K)
 
c	Valeur minimale (k=1) ou maximale (k=2) du tableau A (R*4,N valeurs)
 
	dimension A(N)
	truc=0
	do 100 I=1,n
	truc=truc+A(I)
  100	continue
	truc=truc/n
	if(k.eq.1)	THEN
	do 200 I=1,n
	truc=amin1(truc,a(I))
  200	continue
			ENDIF
	if(k.eq.2)	THEN
	do 300 I=1,n
	truc=amax1(truc,a(I))
  300	continue
			ENDIF
	BINSUP=TRUC
	RETURN
	END
	
	FUNCTION call_chi(R,NUM,NBOITES,kpas)

!	Appelle FUNCTION CHI2 (R,NUM,NBOITES,    Valeurs a fournir a la fonction
!                LIMT,IERR,BIAIS,VARMIN,VARMAX,FINT,FTH)  Parametres annexes
!                                                         rendus par la fonction
!
!      R         tableau de la variable a analyser, R*4, dimension NUM (NUM > 100)
!      NBOITES   nombre d'intervalles pour la partition
!----------------
!      LIMT   nombre de valeurs eliminees (a 2.5 sigma) pour effectuer le test
!      IERR   code d'erreur donnant le nombre d'intervalles ayant moins de 5
!             valeurs.Si au moins un intervalle contient moins de 3 valeurs,
!             le Chi2 est mis a 0.Il est recommande de tester la valeur de IERR
!             a la sortie de la fonction
!      BIAIS  valeur moyenne de VAR,apres elimination des valeurs >2.5 sigma
!      VARMIN barre inferieure d'analyse (R*8)
!      VARMAX barre superieure d'analyse (R*8)
!      FINT   largeur d'un intervalle (R*8)
!      FTH    frequence theorique pour chaque intervalle (dimension NINT)
!
!USAGE      : Declarer VARMIN,VARMAX,FINT en (R*8)
!             Dimensionner R (R*4) et FTH (R*4)
!             Definir le nombre d'intervalles NBOITES.

!                                                       Auteur: Felicitas Arias
!                                                               farias@bipm.org

	Implicit None
	Real*4  call_chi 

	Integer*4 LIMT,IERR,num,nboites,kpas
	Real*4  BIAIS, R(num),FTH(num),chi,CHI2
	Real*8  VARMIN,VARMAX,FINT

c	type*,'Synt_chi:',num,nboites,kpas

	chi=0.
 2750	continue
 	chi=CHI2(r,num,nboites,LIMT,IERR,BIAIS,VARMIN,VARMAX,FINT,FTH)

	IF (chi.eq.0)	THEN
c	   write(6,16)ierr,nboites,chi
c	   write(16,16)ierr,nboites
 16	   format('Call_chi:',i4,'/',i6,' boites vides. Chi^2:',f8.2)
       	   nboites=nboites-kpas		
	   if(nboites.gt.0) go to 2750

c	   write(6,17)ierr,nboites
	   write(16,17)ierr,nboites
 17	   format('Call_chi:',i4,'/',i6,' boites vides. Je sors ')
	   call_chi=0.
	   Return
	ENDIF

	call_chi=chi
	   write(6,16)ierr,nboites,chi
	Return
	End

	FUNCTION CHI2(VAR,NUM,NINT,LIMT,IERR,VMED,VARMIN,VARMAX,
     .  FINT,FTH) 
	
	Parameter (NF=50000)	! Nb de pts dans la serie (sans trous)

	Real*8    SIGVAR,FINT,VARMIN,VARMAX,VARM,EI,P,
	1         ES,CENT(NF),ZETA,DZETA,VM,SIGM
 	
	Real*4    var(NUM),varb(NF),vp(NF),FTH(NINT)
	Integer*4 N(NF)


	SUMD=0.
	SUMVA=0.
	CHI2=0.
	SUMDE=0.
	SUMVAR=0.
	FACT=0.3989422804D0
	IERR=0
	Jtrois=0

C	CALCULO DE VALOR MAS PROBABLE Y SIGMA PUNTO A PUNTO

	DO I=1,NUM
	SUMVA=SUMVA+VAR(I)
	ENDDO

	VM=SUMVA/NUM
	DO I=1,NUM
	SUMD=SUMD+(VAR(I)-VM)**2
	ENDDO

	SIGM=SUMD/(NUM-1)
	SIGM=DSQRT(SIGM)

!		ELIMINACION DE LOS GRANDES VALORES (2.5 sigm)

	numb=num
	L=0
	do 20 I=1,num
	varb(I)=var(I)
	if(ABS(var(I)-vm).ge.2.5*SIGM) go to 20
	L=L+1
	vp(L)=var(I)
  20	continue
	LIMT=num-L
	NUM=L
C            VALOR MEDIO        
        VMED=0
        DO 205 I=1,NUM
        VMED=VMED+VP(I)
  205   CONTINUE
        VMED=VMED/NUM
	do 25 I=1,L
  25	VAR(I)=vp(I)

C	BUSQUEDA DE VARMIN Y VARMAX

	varmin=BINSUP(var,num,1)
	varmax=BINSUP(var,num,2)
        DECAL=(VARMIN+VARMAX)/2.
        VARMIN=VARMIN-DECAL
        VARMAX=VARMAX-DECAL
	RANG=VARMAX-VARMIN
	FINT=RANG/NINT

	DO I=1,NINT
	N(I)=0
	CENT(I)=0
	ENDDO

	DO I=1,NINT
	EI=VARMIN+(I-1)*FINT
	IF(I-NINT)50,51,51
 50	ES=VARMIN+I*FINT
	GO TO 55
 51	ES=VARMAX

 55	CENT(I)=(EI+ES)/2.

	DO J=1,NUM
	IF(VAR(J)-EI)48,46,46
 46	IF(VAR(J)-ES)47,49,48
 49 	IF(ES-VARMAX)48,47,48	
 47	N(I)=N(I)+1
 48	ENDDO	
	if(n(I).lt.5) 	IERR=IERR+1
	if(n(I).lt.3)	jtrois=jtrois+1
	ENDDO


C	CALCULO DE VALOR MAS PROBABLE Y SIGMA	
C
	DO I=1,NINT
	SUMVAR=SUMVAR+N(I)*CENT(I)
	ENDDO

	VARM=SUMVAR/NUM
	DO I=1,NINT
	SUMDE=SUMDE+N(I)*((CENT(I)-VARM)**2)
	ENDDO

	SIGVAR=SUMDE/(NUM-1)
	SIGVAR=DSQRT(SIGVAR)
	DZETA=FINT/SIGVAR

	DO I=1,NINT
	ZETA=DABS(CENT(I)-VARM)/SIGVAR
	P=FACT*DEXP(-(ZETA**2)/2.)
	PHI=NUM*DZETA*P
        FTH(I)=PHI
	CHI2=CHI2+((N(I)-PHI)**2)/PHI
	ENDDO

	CHI2=CHI2/(NINT-4)
	if(jtrois.ne.0) CHI2 = 0
C          RESTITUCION DE LOS VALORES  ORIGINALES
	NUM=NUMB
	do 60 I=1,NUM
  60 	VAR(I)=VARB(I)

	RETURN
	END
	FUNCTION DIVERSIG(R,S,NJ,ICHOIX,RR)

c------------------------------------------------------------------------
c	Calcul d'un certain nombre de statistiques sur une liste
c	(R(I),I=1,NJ), munies des incertitudes S(I)
c	On selectionne la statistique par ICHOIX :

c	1 : P (m.q. pond. des residus / m.q. des sigmas)
c		C'est le nombre utilise comme facteur d'echelle.
c	2 : R moyenne de [(residu / sigma)**2]
c		 C'est le "faux Chi2", ou Goodness-of-fit.
c	3 : C (correlation centrale de R et S)
c	4 : Moyenne quadratique ponderee des R(I) (poids=1/S(I)**2)
c	5 : Moyenne quadratique des R(I)
c	6 : moyenne ponderee de R(I) (poids: S(I)**-2)
c	7 : moyenne de R(I)
c	8 : mediane de R(I) pondere (poids: S(I)**-2)
c	9 : mediane de R(I)

c	Dans les cas 6 a 9, la fonction rend les ecarts
c	R(I)-DIVERSIG dans le tableau RR(I)

c					Auteur: M. Feissel, 1989-2001
c------------------------------------------------------------------------

	Implicit none
	
	Real*4 R(NJ),S(NJ),RR(NJ),RP(NJ),VALMED,DIVERSIG,
     .	       rasig,repoi,resig,recar,remoy,rmoyp    !,CA(1)
	Integer*4 NJ,ICHOIX,L

	rasig=0.
	repoi=0.
	resig=0.
	recar=0.
	remoy=0.
	rmoyp=0.
	do 1226 L=1,nj
	rasig=rasig+S(L)**2
	repoi=repoi+1./(S(L)**2)
	resig=resig+(R(L)/S(L))**2
	recar=recar+R(L)**2
	remoy=remoy+R(L)
	rmoyp=rmoyp+R(L)/(S(L)**2)
	RP(L)=R(L)/(S(L)**2)
!	type*,L,R(L),RP(L)
 1226	continue
      DIVERSIG=0
	if (ICHOIX.eq.1) DIVERSIG=SQRT((resig/repoi)/(rasig/NJ))
	if (ICHOIX.EQ.2) DIVERSIG= resig/(NJ-1)		     	! janv 1991
 
c        IF (ichoix.eq.3) THEN             			! avrl 1991
c           CALL CORREL(r,s,nj,0,ca,1)       
c           DIVERSIG=ca(1)                    
c           RETURN                           
c        ENDIF            

	if (ICHOIX.EQ.4) DIVERSIG=SQRT(resig/repoi)		! juin 1989
	if (ICHOIX.EQ.5) DIVERSIG=SQRT(recar/NJ)	        ! juin 1989

	if (ICHOIX.EQ.6) DIVERSIG=rmoyp/repoi			! janv 1991
	if (ICHOIX.EQ.7) DIVERSIG=remoy/NJ			! janv 1991

      	if (ICHOIX.EQ.8) DIVERSIG=VALMED(RP,NJ)			! sept 2001
      	if (ICHOIX.EQ.9) DIVERSIG=VALMED(R,NJ)			! sept 2001

	IF (ICHOIX.ge.6) THEN
	   do 1230 L=1,NJ
	      RR(L)=R(L)-DIVERSIG
 1230	   continue
	ENDIF

	RETURN
	END

      SUBROUTINE ELCOPO(YEL,DXEL)

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

      COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
      DIMENSION YEL(NF),DXEL(NF,2),DEL(NF,2)
C     LP=LPS/INTERU+0.5

      DO 400 I=1,NT
         DEL(I,1)=DATDEP+INTERU*(I-1)
         DEL(I,2)=(DEL(I,1)-44239.)/365.2422+1980.
c         write(6,16) I,yel(I) 
 16      format('Elcopo: ',i5,f10.3)
  400 CONTINUE
      SQ=0     

      DO 450 I=1,NT
         SQ=SQ+YEL(I)*YEL(I)
  450 CONTINUE
      
      SQ=SQRT(SQ/NT)
      SQB=0     
      NQB=0
      DO 480 I=1,NT
	 if(abs(YEL(I)).ge.belim*SQ) go to 480
	 NQB=NQB+1
         SQB=SQB+YEL(I)*YEL(I)
  480 CONTINUE
      nqf=nt

      IF (NQB.ne.0) THEN
         nqf=nqb
         SQ=SQRT(SQB/NQB)			
      ENDIF

c      WRITE(6,1) SQ,NQF,belim,DEL(1,1),DEL(NT,1)
c      WRITE(16,1) SQ,NQF,belim,DEL(1,1),DEL(NT,1)
    1 FORMAT(' RQM',F10.5,' sur ',I5,' valeurs',
     .      ' (apres ecretage a',f4.1,' sigma)',2F8.0)

      IBP=0
      IBI=0
      DO 500 I=1,NT
         POIDS=1.
         IF (ABS(YEL(I)).GT.BP*SQ) THEN
	    IBP=IBP+1
c            WRITE(6,2) IBP,I,DEL(I,1),DEL(I,2),YEL(I)
    2       FORMAT('GT.BP*SQ',I10,I5,F8.0,F10.3,F7.2)
            POIDS=0.
            DXEL(I,1)=YEL(I)-ELPOND(YEL,I,POIDS)
            TRUC=ELPOND(YEL,I,POIDS)
            DXEL(I,2)=YEL(I)                                 
         ELSE
            IF (ABS(YEL(I)).GT.BI*SQ) THEN
               IBI=IBI+1
c               WRITE(6,3) IBI,I,DEL(I,1),DEL(I,2),YEL(I)
 3             FORMAT('GT.BI*SQ',2I5,F8.0,F10.3,F7.2)
               POIDS=BP-ABS(YEL(I))/SQ
               DXEL(I,1)=YEL(I)-ELPOND(YEL,I,POIDS)
               TRUC=ELPOND(YEL,I,POIDS)
               DXEL(I,2)=YEL(I)*(1.-POIDS)                                 
            ENDIF
         ENDIF

c        IF(I.GT.230.AND.I.LT.280)
c     .  WRITE(6,4)I,YEL(I),POIDS,DXEL(I,1),DXEL(I,2),TRUC
    4    FORMAT(70X,I5,5F7.2)
  500 CONTINUE
      

      krub=100.*FLOAT(nt-nqf)/FLOAT(Nt)
      kruc=100.*FLOAT(IBP)/FLOAT(NQF)
      krud=100.*FLOAT(IBI)/FLOAT(NQF)

c      write(6,66) NQF,krub,belim,kruc,BP,krud,BI
      write(16,66)NQF,krub,belim,kruc,BP,krud,BI
 66   format(i6,' mes. apres ecret. de',i3,'% >',f4.1,'*sig',
     .       '. Rabot:',i3,'% >',f4.1,'*sig;',
     .                           i3,'% >',f4.1,'*sig')

c      WRITE(16,1) SQ,NQF,belim,DEL(1,1),DEL(NT,1)
c    1 FORMAT(' RQM',F7.3,' sur',I5,' valeurs',
c     .      ' (apres ecretage a',f4.1,' sigma)',2F8.0)
c	type*,' '
      RETURN
      END

      SUBROUTINE ELFIL
C
C       FILTRAGE EN SEQUENCE SUR TENDANCE/SAISONNIER/IRREGULIER
C       SOURCE: CENSUS X-11

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

        Real*4 XEL(NF),DXEL(NF,2),serx(NF)

      	Real*4 BP,BI,belim,DATDEP,SERI,TEND,SAIS,SAISb,REST
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT,isort
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),saisB(NF),REST(NF)

c	type*,'ELFIL: interu',interu

	kbcl=1                    ! nb de bouclages pour ELFIL
	isort=3			  ! numero de la sortie de ELFIL (1-3)

      DO 90 I=1,5000   		  
         XEL(I)=0
         TEND(I)=0
         SAIS(I)=0
         REST(I)=0
         serx(I)=0
      DO 90 J=1,2      
         DXEL(I,J)=0                         
   90 CONTINUE   		

      DO 100 I=1,NTOT      
         XEL(I)=SERI(I)                         !B1
  100 CONTINUE

!	type*,'TENDANCE 1 , largeur',limp,' points'
      IRB=0

      CALL ELTEND(XEL,IRB,1)                    !B2-->C1

      DO 200 I=1,NTOT      
         XEL(I)=SERI(I)-TEND(I)                 !B3
  200 CONTINUE
      IRB=1

c      TYPE*,'SAISONNIER 1',lps,' points. Interu:',Interu

      CALL ELSAIS(XEL,IRB)                      !B4,5-->S1

      DO 300 I=1,NTOT
         XEL(I)=SERI(I)-SAIS(I)                 !B6
 16      format('Elfil',i5,3f10.3)
  300 CONTINUE
      LAPM=LPT
      IRB=0

c      TYPE*,'TENDANCE 2 ,largeur',lpair,' points'

      CALL ELTEND(XEL,IRB,2)                    !B7-->C2

      DO 400 I=1,NTOT
         XEL(I)=SERI(I)-TEND(I)                 !B8
  400 CONTINUE
      IRB=1

!      TYPE*,'SAISONNIER 2 ',lps,' points'

      CALL ELSAIS(XEL,IRB)                      !B9,10-->S2
          
C            SORTIE 1

      IF(ISORT.EQ.1) THEN
         TYPE*,'        ****** ELFIL,SORTIE 1 ******'
         GO TO 1050                     
      ENDIF

      IBOUCLE=0
      IRB=0
  450 CONTINUE
      IBOUCLE=IBOUCLE+1
      ITS=(IBOUCLE+1)*2

      DO 500 I=1,NTOT
         XEL(I)=SERI(I)-SAIS(I)-TEND(I)         !B11,12 et C11,12
  500 CONTINUE

!      TYPE*,'FILTRAGE DE L''IRREGULIER',IBOUCLE

      write(16,11) 
 11   format(78('-')/'ELFIL/ELCOPO')

      CALL ELCOPO(XEL,DXEL)                  !B17 et C17

      DO 600 I=1,NTOT
         serx(I)=SERI(I)-DXEL(I,2)               !C,D1
	 XEL(I)=serx(I)
  600 CONTINUE
 
!	type*,'Tendance, largeur',limp,' points'

      CALL ELTEND(XEL,IRB,1)                   !C,D2-->C3,5

      DO 700 I=1,NTOT
         XEL(I)=SERx(I)-TEND(I)                 !C,D4
  700 CONTINUE
  705 format(I8,6f10.3)

c      TYPE*,'SAISONNIER C,D5-->S3,5',lps,' points'

      CALL ELSAIS(XEL,IRB)                   !C,D5-->S3,5

      DO 800 I=1,NTOT
         XEL(I)=SERx(I)-SAIS(I)              !C,D6
 800  CONTINUE    

c      TYPE*,'TENDANCE',ITS,' largeur',lpair,' points'

      CALL ELTEND(XEL,IRB,2)                   !C,D7-->C4,6      

      DO 900 I=1,NTOT
         XEL(I)=SERx(I)-TEND(I)              !C,D9
  900 CONTINUE

      CALL ELSAIS(XEL,IRB)                   !C,D10-->S4,6

C             SORTIE 2

      IF(ISORT.EQ.2) THEN
c	type*,' '
      TYPE*,'        ****** ELFIL,SORTIE 2 ******'
      GO TO 1050
                    ENDIF
      IF(IBOUCLE.le.kbcl) GO TO 450
      DO 1000 I=1,NTOT
         XEL(I)=SERx(I)-SAIS(I)              !D11
 1000 CONTINUE

c      TYPE*,'TENDANCE FINALE ET SORTIE 3, largeur',LPS,' points'

      CALL ELTEND(XEL,IRB,0)                 !D12

C             SORTIE 3

 1050 CONTINUE

      DO 1100 I=1,NTOT
         REST(I)=SERI(I)-SAIS(I)-TEND(I)     !D13
 1100 CONTINUE

      RETURN
      END

      SUBROUTINE ELFIL2(lpsb,chan)
C
C     FILTRAGE EN SEQUENCE SUR TENDANCE/SAISONNIER/IRREGULIER
C               BASCULAGE ENTRE deux TERMES

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,lpsb
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

        Real*4       ANNU(NF),SARI(NF),chan(NF)
	Integer*4    I,itour,J,kbasc,lpsa

!       Declarations pour l'interface avec ELFIL

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

	kbasc=10                   ! nb de bascules pour ELFIL2

      J=1
      DO 210 I=1,NTOT
c	del(I,2)=del(I,2)*100.
        SARI(I)=SERI(I)
	annu(I)=0.
        CHAN(I)=0.
  210 CONTINUE

C    BASCULAGE

      lpsa=lps  ! On sauvegarde la valeur initiale de lps

      DO 240 ITOUR=1,KBASC
      			
         LPS=lpsa

c         type*,'Extraction du cycle A',kbasc
     			
         CALL ELFIL

         DO 220 I=1,NTOT
            SERI(I)=SARI(I)-SAIS(I) ! - Cycle A
            ANNU(I)=SAIS(I)
 220     CONTINUE
      			
         LPS=lpsb

c         type*,'Extraction du cycle B',kbasc
      		
	 CALL ELFIL
                        
         DO 222 I=1,NTOT                           
            SERI(I)=SARI(I)-SAIS(I)  ! - Cycle B
            CHAN(I)=SAIS(I)
 222     CONTINUE

  240 CONTINUE

         
      DO 250 I=1,NTOT
         SERI(I)=SARI(I)                          ! On restitue SERI(I) initial
         sais(I)=annu(I)
         saisb(I)=chan(I)
         REST(I)=SERI(I)-annu(I)-chan(I)-TEND(I)  ! On reconstitue REST(I)
  250 CONTINUE
      			
      LPS=lpsa  ! On retablit la valeur initiale de lps

      Return
      END

      FUNCTION ELPOND(XEL,IX,P)
C
C
C        REMPLACEMENT D'UNE VALEUR EXTREME  
C        PAR MOYENNE SUR 5 CYCLES DE DUREE LP(ex:73)
C        DE VALEURS DE XEL DECALEES DE LP
C           ANNEES 1 ET 2 (DEBUT ET FIN) : MOYENNE SUR 3 ANS

	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

      COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
      DIMENSION XEL(NF)
C
C            ANNEES 1 ET N
C
      LP=LPS/INTERU+0.5
      IF(IX.LE.LP.OR.IX.GT.(NT-LP)) THEN
      IS=1
      IF(IX.GT.(NT-LP))IS=-1
      TRUC=XEL(IX)*P+XEL(IX+LP*IS)      
     .     +XEL(IX+LP*2*IS)
      ELP=TRUC/(P+2.)
                            ELSE
C          ANNEES 2 ET N-1
C
     .IF(IX.LE.(LP*2).OR.IX.GT.(NT-2*LP)) THEN
      TRUC=XEL(IX)*P+XEL(IX+LP)+XEL(IX-LP)
      ELP=TRUC/(P+2.)
                     ELSE
C
C           ANNEES CENTRALES
      TRUC=XEL(IX)*P
     .     +XEL(IX+LP)+XEL(IX-LP)
     .     +XEL(IX+LP*2)+XEL(IX-LP*2)
      ELP=TRUC/(P+4.)
                              ENDIF
      ELPOND=ELP
      RETURN
      END

      SUBROUTINE ELSAIS(XEL,IRB)

!     LISSAGE SUR CINQ CYCLES D'UN TERME DE CYCLE LP 
!             FILTRE B (ANNEES 1 CENTRALES) 
!             TRONQUE A B1 (ANNEES 1 et -1) ET B2 (ANNEES 2 et -2)

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

        Real*4    B(5),B2(4),B1(3),ND2(2),NF2(2),ND1(2),NF1(2),
     .            YEL(NF),DXEL(NF,2),XEL(NF)

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

      DATA B/0.111,0.222,0.334,0.222,0.111/
C             J-2   J-1   *J*   J+1   J+2
      DATA B2/0.259,0.371,0.259,0.111/
C               1    *2*    3     4
C               N    N-1   N-2   N-3
      DATA B1/0.408,0.407,0.185/
C              *1*    2     3
C               N    N-1   N-2

      DO 90 I=1,NF   			! Ajout, juin 97   
      YEL(I)=0
      SAIS(I)=0
      DO 90 J=1,2      
      DXEL(I,J)=0                         
   90 CONTINUE   			! Ajout, juin 97

C      
C         REPERAGE DES AILES PERDUES DANS ELMOYP
C
      LP=LPS/INTERU+0.5      ! Nb de points par cycle
      NAN=5
      LPDEM=LP/2
      LD=LPDEM+1
      LF=NT-LPDEM
c        type*,'ELSAIS: LPS,LP,LPDEM,LD,LF',LPS,LP,LPDEM,LD,LF
C        
C        MOYENNE PAR FILTRE B,ANNEES 3 A N-2
c        type*,'MOYENNE PAR FILTRE B,ANNEES 3 A N-2'
C
      ND=LD+2*LP
      NFI=LF-2*LP
c        type*,ND,NFI
      IBOUCLE=0
   40 CONTINUE
      IBOUCLE=IBOUCLE+1
      DO 100 I=ND,NFI
         ACU=0
         DO 50 J=1,NAN
            KJ=J-NAN/2-1
            ACU=ACU+B(J)*XEL(I+KJ*LP)
   50    CONTINUE
C
C                 AFFECTATION DE SAIS (SAISONNIER)
C
         SAIS(I)=ACU
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
  100 CONTINUE
C
C                ANNEES 2 ET N-1
c                type*,'ANNEES 2 ET N-1'

      ND2(1)=ND-LP
      NF2(1)=ND-1
      ND2(2)=NFI+1
      NF2(2)=NFI+LP
      NAN2=NAN-1

c      TYPE*,'ELSAIS:',ND2(1),NF2(1),ND2(2),NF2(2),NAN2,LP,
c     .' ELMOYP  ANNEES 2 ET N-1 '

      DO 200 K=1,2
         IF(K.EQ.1) IS=+1
         IF(K.EQ.2) IS=-1
         DO 180 I = ND2(K),NF2(K)
            ACU=0
            DO 150 J=1,NAN2
               KJ=(J-NAN/2)*IS
               ACU=ACU+B2(J)*XEL(I+KJ*LP)
  150       CONTINUE
            SAIS(I)=ACU
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
  180    CONTINUE
  200 CONTINUE

C             ANNEES 1 ET N
c             type*,'ANNEES 1 ET N'

      ND1(1)=ND2(1)-LP
      NF1(1)=ND2(1)-1
      ND1(2)=NF2(2)+1
      NF1(2)=NF2(2)+LP
      NAN1=NAN-2

c     TYPE*,'ELSAIS:',ND1(1),NF1(1),ND1(2),NF1(2),NAN1,
c     .' ELMOYP  ANNEES 1 ET N '

      DO 300 K=1,2
         IF(K.EQ.1) IS=1
         IF(K.EQ.2) IS=-1
         DO 280 I=ND1(K),NF1(K)
            ACU=0
            DO 250 J=1,NAN1
               KJ=(J-NAN/2+1)*IS
               ACU=ACU+B1(J)*XEL(I+KJ*LP)
  250       CONTINUE
            SAIS(I)=ACU
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
  280    CONTINUE
  300 CONTINUE
C
C       RECONSTITUTION DES PREMIER ET DERNIER DEMI-CYCLE
c       type*,'RECONSTITUTION DES PREMIER ET DERNIER DEMI-CYCLE'
C
      DO 400 I=1,LPDEM
      SAIS(I)=SAIS(I+LP)
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
      J=NT-I+1
      SAIS(J)=SAIS(J-LP)
c         write(6,16) j,SERI(j),tend(j),SAIS(j) 
  400 CONTINUE

C       MOYENNE NULLE POUR SAIS par moyenne glissante sur un cycle
c       type*,'MOYENNE NULLE par moyenne glissante sur un cycle'

      XBM=0
      DO 420 I=1,NT
      XBM=XBM+SAIS(I)
c         write(6,16) j,SERI(j),tend(j),SAIS(j) 
  420 CONTINUE
      XBM=XBM/NT
	do 430 I=1,nt
	sais(I)=SAIS(I)-XBM
 430	continue

      IF(IRB.EQ.0.OR.IBOUCLE.EQ.2) GO TO 550
      IF(IRB.EQ.1.AND.IBOUCLE.EQ.1)  THEN
      DO 432 I=1,NT
      YEL(I)=XEL(I)-SAIS(I)
  432 CONTINUE


c	write(6,11) 
	write(16,11) 
 11	format(78('-')/'ELSAIS/ELCOPO')

        CALL ELCOPO(YEL,DXEL)

      DO 435 I=1,NT
      XEL(I)=XEL(I)-DXEL(I,1)
c         write(6,16) I,SERI(I),tend(I),SAIS(I) 
 16      format('Elsais',i5,3f10.3)
  435 CONTINUE        
      GO TO 40
              ENDIF
  550 RETURN
      END
      SUBROUTINE ELTEND(XEL,IRB,KPAIR)

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS

        Real*4  XEL(NF),YEL(NF),DXEL(NF,2)

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

!                Pour MCGAUSS

	Real*8    G_A,G_YZ
	Real*4    G_sigma,G_R,G_SIG,G_XS,G_cc
	Integer*4 neq
	Common/CACH/G_A(NF,NIC),G_YZ(NF),G_sigma,G_R(NF),
	1           G_SIG(NIC),G_XS(NIC),G_cc(NIC,NIC)
       
!          MOYENNE GLISSANTE SUR LP POINTS

      DO 90 I=1,NF   			! Ajout, juin 97   
      YEL(I)=0
      TEND(I)=0
      DO 90 J=1,2      
      DXEL(I,J)=0                         
   90 CONTINUE   			! Ajout, juin 97

	if(kpair.eq.1) lapm=limp
	if(kpair.eq.2) lapm=lpair
	if(kpair.eq.0) lapm=LPS

      LP=LAPM/INTERU+0.5
      LPDEM=LP/2

!          ON PERD LP/2 VALEURS AU DEBUT ET A LA FIN

      LD=LPDEM+1
      LF=NT-LPDEM
      IBOUCLE=0
   50 CONTINUE    
      IBOUCLE=IBOUCLE+1
c      TYPE*,'** ELTEND',NT,LP,LPDEM,LD,LF
      
      DO 200 I=LD,LF
         ACU=0
         JD=I-LPDEM
         JF=I+LPDEM
         DO 150 J=JD,JF
            ACU=ACU+XEL(J)/LP
  150    CONTINUE

!          AFFECTATION DE TENDANCE

         TEND(I)=ACU
c        type*,I,TEND(I)
  200 CONTINUE

!      POUR LES PREMIER ET DERNIER DEMI-CYCLE,
!      ON ADOPTE  LA TENDANCE LINEAIRE ADJACENTE

c      TYPE*,'** ELTEND avant'

c		AVANT

	LD2=LD+LPDEM
	orig=datdep+interu*(LD-1)
	neq=0
	do 210 I=LD,LD2
	   neq=neq+1
           G_A(neq,1)=1.d0
           G_A(neq,2)=datdep+interu*(I-1)
           G_YZ(neq)=tend(I)	
  210	continue

        pav=0
	
	CALL MCGAUSS(Neq,2)

	pav=G_XS(2)
	pavv=pav*365.2422
c	if(kpair.eq.0) write(16,2) pavv,orig
c   2	format(78('-')/'ELTEND'/10x, 
c     .         'Pente ',f10.4,' adoptee avant',f7.0)

c		APRES

	LF2=LF-LPDEM
	orig=datdep+interu*(LF-1)
	neq=0
	do 220 I=LF2,LF
	   neq=neq+1
           G_A(neq,1)=1.d0
           G_A(neq,2)=datdep+interu*(I-1)
           G_YZ(neq)=tend(I)	
  220	continue

        pap=0

c      TYPE*,'** ELTEND 2'
	
	CALL MCGAUSS(Neq,2)

	pap=G_XS(2)
	papp=pap*365.2422
c	if(kpair.eq.0) write(16,3) papp,orig
c   3	format(10x, 'Pente ',f10.4,'/an adoptee apres',f7.0)

      DO 280 I=1,LPDEM
         TEND(I)=TEND(LD)+pav*interu*(I-LD)
         J=NT-I+1
         TEND(J)=TEND(LF)+pap*interu*(J-LF)
  280 CONTINUE

c      TYPE*,'** ELTEND 3'

      IF(IRB.EQ.0.OR.IBOUCLE.EQ.2) GO TO 400

      IF (IRB.EQ.1.AND.IBOUCLE.EQ.1) THEN
         DO 300 I=1,NT
            YEL(I)=XEL(I)-TEND(I)
  300    CONTINUE

c	 write(6,11) 

 	 write(16,11) 
11	 format(78('-')/'ELTEND/ELCOPO')

         CALL ELCOPO(YEL,DXEL)

         DO 350 I=1,NT
            XEL(I)=XEL(I)-DXEL(I,2)
  350    CONTINUE
         GO TO 50                              
      ENDIF

  400	continue
        RETURN
      END     
         SUBROUTINE MCGAUSS(NEQ,NINC)                                           

      Implicit none

      Integer*4   NF,NIC
      Parameter (NF=50000)      ! Nb max d'equations
      Parameter (NIC=12)        ! Nb max d'inconnues

      Real*8      U(NIC,NIC),W(NIC,NIC),XX,Y
      Real*4      B(NIC),CALC,SQ                                     
      Integer*4   I,IJ,J,K,LN

      Real*8      T,X
      Real*4      SIGMA,R,SIG,A,CC
      Integer*4   NEQ,NINC
      COMMON/CACH/T(NF,NIC),X(NF),SIGMA,R(NF),
     .            SIG(NIC),A(NIC),CC(NIC,NIC) 
                                                                  
      DO 201 I=1,NINC
  201 B(I)=0.
C
C             1. T(NEQ,NINC) MATRICE DES EQUATIONS D'OBSERVATION
C                B(12)     SECONDS MEMBRES DE CES EQUATIONS
C             2. W(NEQ,NEQ) MATRICE NORMALE
C             3. U(NEQ,NEQ) MATRICE INVERSE
C      CC  MATRICE DE CORRELATION
C      X VECTEUR DES OBSERVQTIONS
C      A  VECTEUR SOLUTION
C      R  RESIDUS
C      SIG  INCERTITUDES SUR LA SOLUTION
C     SIGMA   RESIDU QUADRATIQUE MOYEN

C             EQUATIONS NORMALES

      DO 108  I=1,NINC
  108 B(I) = 0.
      DO 101  I = 1,NEQ
      DO 103 IJ=1,NINC
  103 B(IJ)=B(IJ)+T(I,IJ)*X(I)
  101 CONTINUE
C
C             MOINDRES CARRES.
C
      DO 11 I=1,NINC
      DO 10 J=1,NINC
      U(I,J)=0.0D0
   10 W(I,J)=0.0D0
   11 U(I,I)=1.0D0
      DO 12 I=1,NINC
      DO 12 J=1,NINC
      DO 12 K=1,NEQ
   12 W(I,J)=W(I,J)+T(K,I)*T(K,J)
      DO 16 K=1,NINC
      XX=W(K,K)
      IF(XX.EQ.0.)  GO TO 117
      DO 13 J=1,NINC
      W(K,J)=W(K,J)/XX
   13 U(K,J)=U(K,J)/XX
      DO 15 I=1,NINC
      IF(I.EQ.K) GO TO 15
      Y=W(I,K)
      DO 14 J=1,NINC
      W(I,J)=W(I,J)-Y*W(K,J)
   14 U(I,J)=U(I,J)-Y*U(K,J)
   15 CONTINUE
   16 CONTINUE
      DO 104 IJ=1,NINC
      SIG(IJ)=0
      A(IJ)=0
      DO 104 LN=1,NINC
  104 A(IJ)=A(IJ)+U(IJ,LN)*B(LN)
C
C             RESIDUS...DISPERSION...
C
      SQ=0
      DO 105 I=1,NEQ
      CALC=0
      DO 106 J=1,NINC
  106 CALC=CALC+A(J)*T(I,J)
      R(I)=X(I)-CALC
  105 SQ=SQ+R(I)*R(I)
      SIGMA=SQRT(SQ/(NEQ-NINC))
      DO 107 J=1,NINC
  107 SIG(J)=SIGMA*DSQRT(U(J,J))
         DO 110 I=1,NINC
         DO 110 J=1,NINC
 110  CC(I,J)=U(I,J)/DSQRT(U(I,I)*U(J,J))
      GO TO 119
  117 WRITE(6,118)  K,((W(I,J),I=1,NINC),J=1,NINC)
  118 FORMAT(//' DIVISEUR NUL DANS MCGAUSS',I6,/12(12F10.5/))
  119 CONTINUE
      RETURN
      END

	Subroutine NETCENT(pt,ntot)

!       date,pt,ntot: dates, poids et nb de pts dans la serie 

!       Elimination des points aberrants et transmission de la mediane

!       On retourne la serie (SERI, DATE, PT) compactee, 
!       SANS les points aberrants (listes dans crono_gmt.echo)
!       Le nombre de points conserves est encore NTOT (valeur modifee)

	Implicit none
	Integer*4   NF
	Parameter (NF=50000)

      	Real*4      vmoy,DIVERSIG,sr(ntot),pr(ntot),rr(ntot),
	2           BINSUP,rabs(ntot),ref
	Integer*4   I,kt,ntot,ntor,nref

!       Declarations pour l'interface avec CRONO: seri, date,tref,pt

	Character*6 nom_var            ! nom de l'unite en sortie
      	Real*8      date,dlim
      	Real*4      SERI,TEND,SAIS,SAISb,REST, tref,geri,  
	1           pt(NF),elim,centre,ecmax,fac
	Integer*4   nlim
	COMMON/DONNEES/date(NF),nom_var,tref(NF),geri(NF)
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)
	COMMON/ELIMS/dlim(NF),elim(NF),nlim,centre,ecmax,fac
!        0         0         0         0         0         0         |72

!           Calcul de la moyenne

	if(ntot.gt.NF) stop 'NETCENT: trop de mesures'

c	write(6,1) 
	write(16,1)
 1	format(78('-')/'NETCENT   Eliminations avant analyse.')

c	type*,'NETCENT:', ntot,seri(1),seri(ntot)

        do 100 I=1,ntot
	   sr(I)=seri(I)
	   pr(I)=1
 100	continue
	ntor=ntot+1
	nlim=0

 150	continue
	ntor=ntor-1
	nref=0

	vmoy=DIVERSIG(sr,pr,Ntor,6,rr)            ! moyenne "ponderee" (0/1)
	ref=DIVERSIG(rr,pr,Ntor,5,rr)             ! ecart-type/vmoy

!        Recherche des points ayant |residu|> fac*ref

           do 260 I=1,ntor
	      IF (ABS(rr(I)).gt.fac*ref) THEN
	         pr(I)=0 
		 nlim=nlim+1
		 elim(nlim)=seri(I)
		 dlim(nlim)=date(I)
	         nref=nref+1
c	         write(6,2)  rr(I),fac,ref,nref,date(I),seri(I),nlim
	         write(16,2) rr(I),fac,ref,nref,date(I),seri(I),nlim
 2	         format('Res.:',f12.4,'>',f4.0,'*',f12.4,
	1	       ' Date:',i2,f12.4,'  Val.:',f12.4,i4)
c		 type*,'NETCENT:',nlim,dlim(nlim),elim(nlim)
	      ENDIF
 260	   continue

	   if(nref.eq.0) go to 300

!        On reforme la liste sans ces points

	   kt=0
	   do 290 I=1,ntor
	      if(pr(I).eq.0) go to 290
	      kt=kt+1

	      sr(kt)=sr(I)
	      pr(kt)=1.

	      seri(kt)=seri(I)
	      date(kt)=date(I)
	      tref(kt)=tref(I)
	      pt(kt)=pt(I)
 290	   continue

	   go to 150
 300	   continue

	ntot=ntot-nlim
	centre=DIVERSIG(sr,pr,Ntot,8,rr)          ! mediane "ponderee" (0/1)

        do 305 I=1,ntot
c	   if(I.ge.ntot-13)type*,I,date(I),1043.+(date(I)-51545.)/7.
	   rabs(I)=ABS(rr(I))
 305	continue

	ecmax=BINSUP(rabs,ntot,2)

	if(nlim.ne.0)
	1    type*,'   Eliminination (|ecart| >',fac,'*sigma):',
	2    nlim,' mesure(s)'

	return
	end

      SUBROUTINE SPFIL(NT,NP,XZR,XX,YY,itr)

!		  NT mesures, NP periodes

	Implicit none

	Integer*4   NF,Nsp,NIC
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Nsp=1000)  ! Nb de pts du spectre (spfil.f)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS


        Real*8     XX(NT)
      	Real*4     XZR,YY(NT),PER(NP),                 !pds(NT),
	1          P1,P2,F2,FAS,FRQ,FRA,F,D,ARG,PRA
	Integer*4  I,itr,JJ,NT,NP

!                Pour MCGAUSS

	Real*8   A,YZ
	Real*4   sigma,R,SIG,XS,cc
	Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
     .              SIG(NIC),XS(NIC),cc(NIC,NIC)

!       Declarations pour l'interface avec CRONO

      	Real*4    fr,amp,samp,pt,Per1,Per2
	Integer*4 NR
	COMMON/SPECTRES/fr(Nsp,2),amp(Nsp,2),samp(Nsp,2),
	1               NR(2),pt(NF),per1(2),per2(2)

        p1=per1(itr)     ! itr=1: tend   itr=2: rest
        p2=per2(itr)

	WRITE(16,5)  P1,P2,NT,XX(1),XX(NT),np,XZR
    5 	FORMAT(78('-')/
     .          'SPFIL: Periodogramme (moindres carres):',F8.3,' ->',
	1 	F9.3,' jours'/I6,' mesures,',F9.2,' -',F9.2,',',
	2 	i4,' raies. Tzero=',F9.2)

	F2=1/P1
	FAS=(1./P2-1./P1)/NP

	DO 4  JJ=1,NP
           FRQ=F2+(JJ-1)*FAS      ! frquence en cycles/jours
           FRA=FRQ*365.2422       ! frquence en cycles/an
           PER(JJ)=1./FRQ         ! priode en jours
           PRA=PER(JJ)/365.2422   ! priode en annes
           F=6.283185/PER(JJ)

           DO 3  I=1,NT
c              pt(I)=PDS(I)
c              D=SQRT(PDS(I))
              D=SQRT(pt(I))
              ARG=(XX(I)-XZR)*F
              A(I,1)=D
              A(I,2)=D*SIN(ARG)
              A(I,3)=D*COS(ARG)
              YZ(I)=YY(I)*D
 3	   continue

	   CALL MCGAUSS(NT,3)

	   FR(JJ,itr)=FRQ          ! frquence en cycles/jours
           AMP(JJ,itr)=SQRT((XS(2)**2)+(XS(3)**2))
           SAMP(JJ,itr)=SQRT((SIG(2)**2)+(SIG(3)**2))

c           if (JJ.eq.NP) 
c     .          type*, itr,FR(JJ,itr),AMP(JJ,itr),SAMP(JJ,itr)

    4 CONTINUE
      RETURN
      END

      SUBROUTINE TRIDIN(TAB,LB,NB)

c      DIMENSION TAB(NB),LB(NB)
      INTEGER*4 TAB(NB),LB(NB)

C     SUBROUTINE DE TRI DICHOTOMIQUE INDIRECT
C     TAB  LISTE DES VALEURS DONT ON VEUT CONNAITRE LORDRE CROISSANT
C     LB   LISTE D'INDICE D'ACCES DE TAB

C     WRITE(6,901)(TAB(K),K=1,NB)
  901 FORMAT('**TRIDIN ',10I12)
      IF(TAB(1).GT.TAB(2))GOTO10
      LB(1)=1
      LB(2)=2
      GOTO12
  10  LB(2)=1
      LB(1)=2
  12  IC=2
  15  IC=IC+1
      IF(IC.GT.NB)RETURN
      IMIN=1
      IMAX=IC-1
      J=LB(1)
      IF(TAB(IC).GT.TAB(J))GOTO18
      IDEC=1
      GOTO35
  18  J=LB(IMAX)
      IF(TAB(IC).GE.TAB(J))GOTO30
  19  IF(IMAX-IMIN.LE.1)GOTO25
      IT=(IMAX+IMIN)/2
      J=LB(IT)
      IF(TAB(IC).GE.TAB(J))GOTO20
      IMAX=IT
      GOTO19
  20  IMIN=IT
      GOTO19
  25  J=LB(IMIN)
      IF(TAB(IC)-TAB(J))26,27,29
  26  IDEC=IMIN
      GOTO35
  27  IDEC=IMAX
      GOTO35
  29  J=LB(IMAX)
      IF(TAB(IC).LT.TAB(J))GOTO27
  30  IDEC=IMAX+1
      GOTO38
  35  IM=IC-1
      I=IC
      DO 37 II=IDEC,IM
      I=I-1
  37  LB(I+1)=LB(I)
  38  LB(IDEC)=IC
      GOTO15
C     WRITE(6,901)( LB(K),K=1,NB)
      END

      FUNCTION VALMED(X,N)

c	Copie de [numrec]mdian1.f, 
c	en remplacant CALL SORT par CALL TRIDIN
c					       Auteur: M. Feissel 
c							sept 2001
      
      Implicit none

      Real*4 X(N),VALMED,XMAX,BINSUP
      Integer*4 I,N,N2,KT(N),LB(N)

      N2=N/2

      XMAX=BINSUP(X,N,2)		! max de la serie

      DO I=1,N
! 	 transformation en entier apres une normalisation 
! 	 supposant que la dynamique de la serie est < 10**6

	 KT(I)= X(I)/ABS(XMAX)*1.e+06	         
      ENDDO

      CALL TRIDIN(KT,LB,N)

      IF (2*N2.EQ.N) VALMED=0.5*( X(LB(N2))+X(LB(N2+1)) )	! N pair
      IF (2*N2.NE.N) VALMED=X(LB(N2+1))				! N impair

      RETURN
      END
	Subroutine VARBRUIT(ntot,kpo,pjour)

!       Analyse par la variance de paire et identification du type de bruit

!       ntot:  nb de pts dans serie sans trous
!       pjour: intervalle tabulaire en jours
!       pcy:  periode du cyclique en jours (ncy: nb de pts serie avec trous)

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,Ncc,Nst,NIC
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (Ncc=1000)  ! Nb de cycles sur la duree totale 
	Parameter (Nst=1000)  ! Nb de variances d'Allan (common STAT)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS

	Character*9 ent(7)
      	Real*8      rv(NF)
      	Real*4      pjour,tau0,tau(Nst),varp(Nst),var(Nst),rc(NF)
	Integer*4   I,k,kh,ks,L,ntot,m,mvr,kpo  !,m_varp

!       Declarations pour l'interface avec CRONO: tend,rest,geri

      	Real*4    SERI,TEND,SAIS,SAISb,REST 
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

	Character*6  nom_var            
      	Real*8       date
      	Real*4       tref,geri
	COMMON/DONNEES/date(NF),nom_var,tref(NF),geri(NF)

!       Declarations pour l'interface avec CRONO_VUE: br_tend,br_rest

!        0         0         0         0         0         0         *72*
	Real*4    biastend,pentend,spentend,pent,sent,rms_rest,
	1         chi_rest,call_chi,tz,vz,pcy,pv
	Integer*4 nvz,nchi,nboites,kpas,kab
	Common/STAT/pcy(3),kab,biastend,pentend,spentend,pent(7),sent(7),
     .              tz(Nst,7),vz(Nst,7),nvz(7),rms_rest,chi_rest,pv(NF)
!       1: tend+rest; 2:tend;  3: rest;    
!       4: ampl_saisA1; 5: ampl_saisA2; 6: ampl_saisB1; 7: ampl_saisB2

!       Pour transmettre en retour les variations du/des cyclique(s)

	Real*8    datecy,datav,t_datecy(Ncc),dpcy
	Real*4    cyc,scyc,t_cyc(Ncc,2,2)
	Integer*4 J,ncy,nvar,itrou(2,2),kt(2,2),NS
	Common/CYCL/datecy(Ncc,2),cyc(Ncc,2,2),scyc(Ncc,2,2),ncy(2),NS

!                Pour MCGAUSS

	Real*8   A,YZ
	Real*4   sigma,R,SIG,XS,cc
	Common/CACH/A(NF,NIC),YZ(NF),sigma,R(NF),
	1           SIG(NIC),XS(NIC),cc(NIC,NIC)

	Data ent/'Tout     ','Tendance ','Reste    ',
	1        'Sais A1  ','Sais A2  ','Sais B1  ', 'Sais B2  '/

C        Nst=100

c	type*,'VARBRUIT: ntot, pjour, pcy,NS',ntot,pjour, pcy,NS

	write(16,1)
 1	format(78('-')/'VARBRUIT: variances d''Allan et chi^2 du reste')

c	type*,'Varbruit - pcy:',pcy

!           Calcul du Chi_2 pour rest pondere

	nchi=0
	DO 50 I=1,ntot
	   if(pv(I).eq.0) go to 50  ! On saute les trous
	   nchi=nchi+1
	   if(kpo.eq.0) rc(nchI)=rest(I)
	   if(kpo.eq.1) rc(nchI)=rest(I)/geri(I)	   
 50	continue

	type*,'Calcul du chi^2'

	chi_rest=0.
	IF (nchi.gt.150) THEN
	   nboites=50
	   if(nchi.lt.500) nboites=FLOAT(nchi)/10.
	   kpas=1
	   chi_rest=CALL_CHI(rc,nchi,nboites,kpas)
	ENDIF

c	write(6,67) chi_rest
	write(16,67) chi_rest
 67	format('*** Chi^2 du reste:',f6.2,' ***')

!       Preparation de la serie des amplitudes du 1 cycle et 1/2 cycle
!       on comble les trous

	DO 300 ks=1,NS   ! ks=1: saisA;  ks=2:saisB

	   do 200 kh=1,2 ! la fondamentale et la 1ere harmonique

c	      type*,'Varbruit 200:ks, kh, ncy(ks)',ks, kh, ncy(ks)

	      itrou(ks,kh)=0
	      J=0
	      kt(ks,kh)=0
c	      datav=datecy(1,ks)-pcy(ks)/FLOAT(kh)
	      dpcy=pcy(ks)
	      if(kab.ne.0) dpcy=pcy(3)
	      datav=datecy(1,ks)-dpcy/FLOAT(kh)
 100	      J=J+1

	      if(J.gt.ncy(ks)) go to 150
 110	      continue

!             Test de l'intervalle entre deux dates avec amplitudes estimees

	      IF (DABS(datecy(J,ks)-datav-dpcy).le.0.5d0*dpcy) THEN
	         kt(ks,kh)=kt(ks,kh)+1

c	      if(J.eq.1.or.J.eq.ncy(ks)) type*,'-- ',
c	1     J,kt(ks,kh),datecy(J,ks)-datav-dpcy,0.5d0*dpcy

		 IF(kt(ks,kh).gt.NCC) THEN
		    type*,'** ERREUR'
		    type*, '** Augmenter la valeur du parametre Ncc',
	1		   ' dans les programmes suivants:'
		    type*, '** crono_vue.f   crono.f   varbruit.f'
		    type*, '** La valeur actuelle (',Ncc,
	1		   ') est trop faible'
		    STOP
		 ENDIF
	         t_cyc(kt(ks,kh),ks,kh)=cyc(J,ks,kh)
		 t_datecy(kt(ks,kh))=datecy(J,ks)
		 datav=t_datecy(kt(ks,kh))
		 go to 100
	      ELSE
		 itrou(ks,kh)=itrou(ks,kh)+1
		 kt(ks,kh)=kt(ks,kh)+1

		 IF(kt(ks,kh).gt.NCC) THEN
		    type*,'** ERREUR'
		    type*, '** Augmenter la valeur du parametre Ncc',
	1		   ' dans les programmes suivants:'
		    type*, '** crono_vue.f   crono.f   varbruit.f'
		    type*, '** La valeur actuelle (',Ncc,
	1		   ') est trop faible'
		    STOP
		 ENDIF

		 t_cyc(kt(ks,kh),ks,kh)=cyc(J-1,ks,kh)
		 t_datecy(kt(ks,kh))=t_datecy(kt(ks,kh)-1)+pcy(ks)
		 datav=t_datecy(kt(ks,kh))

c		 write(6,66)pcy(ks),t_datecy(kt(ks,kh)),
c	1	       t_cyc(kt(ks,kh),ks,kh),itrou(ks,kh)

		 write(16,66)pcy(ks),t_datecy(kt(ks,kh)),
	1	       t_cyc(kt(ks,kh),ks,kh),itrou(ks,kh)
 66		 format('Trou comble dans ampl. cyclique:',f10.3,' d',
	1	   2f12.4,i3)

		 go to 110
	      ENDIF

 150	      continue

c	      type*,'VARBRUIT:',ks,kh,pcy(ks),itrou(ks,kh)

 200	   continue	! kh: la fondamentale et la 1ere harmonique
 300	CONTINUE        ! ks=1: saisA;  ks=2:saisB

!           CALCUL DES VARIANCES DE PAIRE

	type*,'Variances d''Allan'

        do 500 k=1,5+2*(NS-1)
	   IF(k.le.3) THEN

	      type*,'   ',ent(k)
	      do 480 L=1,ntot
	         if(k.eq.1) RV(L)=seri(L)     !tend(L)+rest(L)		
	         if(k.eq.2) RV(L)=tend(L)		
	         if(k.eq.3) RV(L)=rest(L)		
 480	      continue
	      nvar=ntot
	      tau0=pjour

	   ELSE

	      IF (k.eq.4.or.k.eq.6) THEN

		 ks=(k-2)/2       ! ks=1: saisA;  ks=2:saisB
           
	         if(MOD(k,2).eq.0)
	1        type*,'   Amplitude cyclique(s)',
	2	       pcy(ks),.5*pcy(ks),' jours'

	         do 495 kh=1,2
	     
	            if(itrou(ks,kh).ne.0.and.MOD(kh,2).eq.0) 
	1	    WRITE(6,6)itrou(ks,kh)
 6	            format(i6,' trous combles dans serie des amplitudes')
		 
	            do 490 L=1,kt(ks,kh)
	    	       RV(L)=t_cyc(L,ks,kh)		
 490	            continue
	            nvar=kt(ks,kh)
	            tau0=pcy(ks)

c		    type*,ks,kh,kt(ks,kh),rv(1),rv(kt(ks,kh))

 495	          continue

	      ENDIF
	   ENDIF

	   CALL ALLAN(nvar,RV,Tau0,VARP,0)

c      	   if(k.eq.1) write(6,20) ent(k)                                       
      	   write(16,20) ent(k)                                       
   20 	   FORMAT(/2X,'VARIANCES D''ALLAN ',a/
	1	        8X,'TAU (d)',8X,'SIG'/)
      	   DO 1282 M=1,Nst
      	      IF(VARP(M).EQ.0) GO TO 1283
      	      TAU(M)=Tau0*2**(M-1)
      	      VAR(M)=VARP(M)*VARP(M)
      	      write(16,21)M, TAU(M),VARP(M)      
   21 	      FORMAT(i5,F10.2,F12.4)
 1282 	   CONTINUE
 1283 	   CONTINUE
      	   MVR=M-1   
!          nombre de varp caculees (on ne conserve pas la derniere)
	   nvz(k)=mvr

	   IF (mvr.gt.nst) THEN
	      type*,'Le parametre NST de crono_vue.f, crono.f et',
	1	    ' varbruit.f est <',mvr
	      STOP
	   ENDIF

!	Preparation des donnees pour le Common STAT

	   do 1307 M=1,mvr	!  M - les Taus 
! indexation
	      TZ(M,k)=tau(M)
	      VZ(M,k)=var(M)
c      	   if(k.eq.1) type*,'varbruit',k,M, TZ(M,k), VZ(M,k)                                  
 1307 	   CONTINUE

 500	continue
	return
	end
